package com.connor.signoff.soa.handler;

import java.io.InputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;

import java.io.IOException;

import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.MalformedURLException;
import java.net.SocketException;
import java.net.URISyntaxException;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.concurrent.TimeoutException;
import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.net.ftp.FTPFile;
import org.apache.commons.net.ftp.FTPReply;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

import com.itextpdf.text.BadElementException;
import com.itextpdf.text.Image;
import com.itextpdf.text.Rectangle;
import com.itextpdf.text.pdf.PdfContentByte;
import com.itextpdf.text.pdf.PdfGState;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.PdfStamper;
import com.teamcenter.clientx.AppXSession;
import com.teamcenter.services.strong.administration.PreferenceManagementRestBindingStub;
import com.teamcenter.services.strong.administration.PreferenceManagementService;
import com.teamcenter.services.strong.administration._2012_09.PreferenceManagement;
import com.teamcenter.services.strong.core.DataManagementService;
import com.teamcenter.soa.client.model.ModelObject;
import com.teamcenter.soa.client.model.strong.Dataset;
import com.teamcenter.soa.client.model.strong.User;
import com.teamcenter.soa.client.model.strong.WorkspaceObject;
//import com.teamcenter.rac.aif.AbstractAIFApplication;
//import com.teamcenter.rac.aif.kernel.AIFComponentContext;
//import com.teamcenter.rac.aifrcp.AIFUtility;
//import com.teamcenter.rac.ui.common.RACUIUtil;
//import com.teamcenter.rac.util.FileUtility;
//import com.teamcenter.rac.util.MessageBox;
//import com.teamcenter.soa.client.model.Property;
//import com.teamcenter.soa.client.model.strong.User;
//import com.teamcenter.soa.exceptions.NotLoadedException;


/**
 * ̳ϵͳInterfaceDatasetAction࣬дpreProcessڴ ݼ ʱǰ
 * 
 * @author hubing
 * @version 1.0, 2015-01-6
 */

public class OpenDatasetSignoff{
	private static final boolean debug = false;
	private static String exePath;//·
	private static String[] refValues;//ӳ
	private static AppXSession session;
//	private static PreferenceManagementService tcp;
//	private TCPreferenceService tcp;
	// رݼʱ򴥷ǿͨ˷ʵִݼļԵǵı߰汾
	private int waitPdf = 0;
	private int count = 0;// 

	public static void main(String[] args) {
		if (args.length > 0) {
			if (args[0].equals("-help") || args[0].equals("-h")) {
				System.out.println("usage: java [-Dhost=http://server:port/tc] com.teamcenter.hello.Hello");
				System.exit(0);
			}
		}

		// Get optional host information
		String serverHost = "http://192.168.2.242:7001/tc";
		String host = System.getProperty("host");
		if (host != null && host.length() > 0) {
			serverHost = host;
		}

		session = new AppXSession(serverHost);
//		HomeFolder home = new HomeFolder();
//		Query query = new Query();
//		DataManagement dm = new DataManagement();

		// Establish a session with the Teamcenter Server
		User user = session.login();

		PreferenceManagementService tcp = PreferenceManagementService.getService(AppXSession.getConnection());
		String path = "C:\\Users\\HX\\eclipse-workspace\\";
		exePath = path;//.substring(1, path.indexOf("com.connor.signoff")).replace("/", "\\");
//		refValues = tcp.getStringArray(TCPreferenceService.TC_preference_site, "HxCaxaMapping");
		PreferenceManagement.GetPreferencesResponse getAttrMappingPreferencesResponse = tcp.getPreferences(new String[] {"HxCaxaMapping"}, true);
		for(PreferenceManagement.CompletePreference completePreference : getAttrMappingPreferencesResponse.response) {

            if(completePreference.definition.name.equals("HxCaxaMapping")){
            	refValues = completePreference.values.values;
            }
        }
		FTPUtils.getConfigureInfomationg(tcp,"");
		
		
		preProcess("hgiN5tO1I3go1D");
		
		session.logout();

	}

	
	public static int preProcess(String datasetPuid) {
		System.out.println("汾2023-04-12preProcess...");
		//ȡݼ
		DataManagementService dataManagementService = DataManagementService.getService(AppXSession.getConnection());
		Dataset dataset = (Dataset) dataManagementService.loadObjects(new String[] {datasetPuid}).getPlainObject(0);
		//ݼУ
		if(!dataSetVerification(dataset)) {return 0;}
		
		//ִдCAXAɹע޸
//		openCad();
//		
//		// ѾļҲҪжǷҪӳ
		// caxaݼֻģ޸ʱ<=ʱ䣬pdf޸ʱ>ʱ,ֻ򿪣Ҫӳתpdf
		boolean openDirect = false;// trueΪpdf
//		openDirect = isCaxaDatasetRegen(tccomponentdataset, openDirect);
		
		if (openDirect) {
			return 0;
		}
//		//ȡTCݼ·
//		String exportedCaxaFilePath = TcUtils.getCaxaFile(arg1);
//		
//		if (openDirect && exportedCaxaFilePath != null) {
//			if (debug)
//				System.out.println("ǩ:" + exportedCaxaFilePath);
//			//Ҫǩ
//		}else {
//			if (debug)
//				System.out.println("ǩ:" + exportedCaxaFilePath);
//			//Ҫǩ
//		}
//
//		if (exportedCaxaFilePath != null && (exportedCaxaFilePath.toLowerCase().endsWith(".exb")
//				|| exportedCaxaFilePath.toLowerCase().endsWith(".cxp"))) {
//			try {
//				
//				hx_SetCAXAFileOrigin(tccomponentdataset, tcp, "",openDirect);
//				
//			} catch (Exception e) {
//				e.printStackTrace();
//				MessageBox.post("Teamcenter쳣"+e.getMessage(), "", MessageBox.ERROR);
//			}
//		}
//		//openCad();
		return 0;
	}
//	
//	@Override
//	public boolean postProcess(TCComponentDataset arg0, String arg1, int arg2) {
//		System.out.println("PostProcess...");
//		System.out.println("PostProcess汾:2023-05-22...");
//		//ݼУ
//		
//		if(!dataSetVerification(arg0)) {return false;}
//		File finalCaxa =TcUtils.getCaxaFile(arg1);
//		
//		openCad();
//		boolean openDirect = false;// trueΪpdf
//		// caxaݼֻģ޸ʱ<=ʱ䣬pdf޸ʱ>ʱ,ֻ򿪣Ҫӳתpdf
//		openDirect = isCaxaDatasetRegen(arg0, openDirect);
//		if (openDirect) {
//			deleteTempReadOnlyFile(arg1, finalCaxa);
//			return false;
//		}
//
//		count = 0;
//		//ȡеȴpdfתʱʱ
//		loadWaitPdf();
//		TCComponentItemRevision rev = TcUtils.getReferenceRev(arg0);
//		if (rev != null) {
//			String addPdfPath = "";
//			try {
//				if (debug)
//					System.out.println("ܿ");
//				// ʱʩ ޸ʱͷʱС2ӣһӳ䣬תpdf
//				String ftpCaxaName = "";
//				if (!openDirect) {
//					ftpCaxaName = caxaProperty(rev, arg0, finalCaxa);// ӳתpdf
//				}
//					// ܿ
//					addPdfPath = addSkz(addPdfPath, ftpCaxaName, rev);
//				
//				if (debug)
//					System.out.println("ܿ");
//				
//				if (addPdfPath.length() > 0) {
//					if (debug)
//						System.out.println("滻");
//					// 滻½ݼ
//					ChangeDbomUtil.setByPass(true);
//					replaceOrcreate(arg0, rev, session, addPdfPath);
//					ChangeDbomUtil.setByPass(false);
//				}
//			
//			} catch (Exception e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//				MessageBox.post("Teamcenter쳣"+e.getMessage(), "", MessageBox.ERROR);
//			}
//		}else if (rev == null) {
//			MessageBox.post("ݼ汾pdfתʧ", "", MessageBox.INFORMATION);
//		}
//
//		//޸bugҪɾֻļ
//		deleteTempReadOnlyFile(arg1, finalCaxa);
//		return false;
//	}
	/**
	 * ݼУ
	 * @param dataset 
	 * @param tccomponentdataset ݼ
	 * @return
	 */
	private static boolean dataSetVerification(Dataset dataset) {
		//ûPDF
//		if(TcUtils.checkPDF(dataset) == 1) {return false;}
				
		//жǷģݼǣ򷵻
//		if (judgeModel(dataset) == 1) {return false;}
//		
//		//ԭļǷ쳣
//		if(TcUtils.checkDatasetFileName(dataset) == 1) {return false;};
		
		
		return true;
		
	}
//	/**
//	 * ɾTCжΪֻȻҪǩֵļ
//	 * @param tcTempDir
//	 * @param finalCaxa
//	 */
//	private void deleteTempReadOnlyFile(String tcTempDir, File finalCaxa) {
//		File tempCacheFile;
//		File[] allFiles;
//		
//		if(finalCaxa.exists()) {
//			
//		}
//		// ֻ򿪣ҽcaxaǩֵ£ļ ᱨ
//		boolean caxaReadOnly = !finalCaxa.canWrite();
//		if (caxaReadOnly) {
//			tempCacheFile = new File(tcTempDir);
//			allFiles = tempCacheFile.listFiles();
//			for (int i = allFiles.length - 1; i >= 0; i--) {
//				allFiles[i].delete();
//			}
//		}
//	}
//	
//	
//	
//	/**
//	 * @param addPdfPath PDFǩ
//	 * @param ftpCaxaName
//	 * @param rev
//	 * @return
//	 * @throws Exception 
//	 */
//	private String addSkz(String addPdfPath,String ftpCaxaName,TCComponent rev) throws Exception {
//		String fileName="";
//		String item_id ="";
//		String item_rev_id ="";
//		String qianzhang = "";
//		item_id=rev.getProperty("item_id").trim();
//		item_rev_id=rev.getProperty("item_revision_id").trim();
//		item_id = TcUtils.newString(item_id);
//		qianzhang = rev.getProperty("hx3_qianzhang").trim();
//		if(ftpCaxaName.length()>0) {
//			fileName=ftpCaxaName.split(".exb")[0];
//			// ȡݼڵİ汾ƴӰ汾id͵ǰʱΪϴ
//			boolean ss = false;
//			//ӳpdfļ
//			count = 0 ;
//			boolean convertMark = FTPUtils.downFile(fileName + ".pdf", System.getenv("TEMP"));// pdf·
//			if (convertMark == false) {
//				if (count > waitPdf) {
//					
//					MessageBox.post("CAXAתPDFʱ,", "", MessageBox.INFORMATION);
//				} else {
//					
//					MessageBox.post("CAXAתPDF쳣,", "", MessageBox.INFORMATION);
//				}
//			} else {
//				// Ҫǩ
//				String addSkzBeforePath=System.getenv("TEMP") + File.separator + fileName + ".pdf";
//				String addSkzAfterPath="";
//				if(FTPUtils.CompanyName.equals("HX")) {
//					addSkzAfterPath=System.getenv("TEMP") + File.separator + item_id + item_rev_id + ".pdf";
//					String designType = rev.getType();
//					String[] imgPath = new String[1];
//					if(qianzhang.equals("ܿ") || qianzhang.equals("B") || qianzhang.isEmpty()) {
//						
//						exePath = exePath + "skz.png";
//					}
//					else {
//						exePath = exePath + "syz.png";
//					
//					}
//					
//					imgPath[0] = exePath;
//					System.out.println("ܿλ---------------" + imgPath[0]);
//					addPdfMark(addSkzBeforePath,addSkzAfterPath, imgPath,designType);
//				}
//				
//				File file = new File(addSkzBeforePath);
//				if (file.exists()) {
//					addPdfPath = addSkzBeforePath;
//				} else {
//					
//					addPdfPath = addSkzAfterPath;
//				}
//				
//			}
//		}
//		return addPdfPath;
//	}
//
//	
//	
//	/**
//	 * ǩֲȡǩֺPDF
//	 * @param rev 
//	 * @param dataset
//	 * @param finalCaxa
//	 * @return
//	 * @throws Exception
//	 */
//	public String caxaProperty(TCComponentItemRevision rev, TCComponentDataset dataset,File finalCaxa) throws Exception {
//		// Ҫݼ·
//
//				if (dataset != null) {
//					String fileOgiginName = "";
//					// аcxp,
//					if (dataset.getProperty("object_name").contains(".cxp")
//							|| dataset.getProperty("object_name").contains(".CXP")) {
//						return "";
//					}
//
//					// TODO õԭļ
//					TCComponent[] ref_list = dataset.getTCProperty("ref_list").getReferenceValueArray();
//					if (ref_list.length == 0) {
//						return "";
//					}
//					if (ref_list.length > 1) {
//						return "";
//					}
//					if (ref_list.length == 1) {
//						fileOgiginName = ref_list[0].getProperty("original_file_name");
//					}
//
//					// TODO Ⱥϴcaxaxmlļftpת
//					String tempCaxaPath = "";
//					System.out.println("ʼtempCaxaPath");
//					System.out.println(dataset.getProperty("object_name"));
//					tempCaxaPath = TcUtils.downLoadCaxaFile(dataset, rev, finalCaxa);// ļsystem temp·£Ϊǰʱ
//
//					// пΪգ粻õʱ
//					if (tempCaxaPath.trim().length() == 0) {
//						return "";
//					}
//					System.out.println(tempCaxaPath);
//					System.out.println("tempCaxaPath   caxaƵ·:" + tempCaxaPath);
//					String tempCaxaPathName = tempCaxaPath.substring(tempCaxaPath.lastIndexOf("\\") + 1);
//					second(new File(tempCaxaPath));
//					FileInputStream tempCaxaPathIn = new FileInputStream(new File(tempCaxaPath));
//					System.out.println("ʼϴtempCaxaPath:" + tempCaxaPathName);
//					boolean tempCaxa = FTPUtils.uploadFile(tempCaxaPathName, tempCaxaPathIn);
//					if (tempCaxa == false) {
//						System.out.println("upload fail----------------");
//						return "";
//					}
//
//					System.out.println("ϴcaxa");
//					boolean jump = hx_SetCAXAFile2(dataset, tcp, tempCaxaPathName.substring(0, tempCaxaPathName.length() - 4));
//					if (jump == false) {
//						return "";
//					}
//					second(new File(tempCaxaPath.replace(".exb", ".xml")));
//
//					FileInputStream tempXmlPathIn = new FileInputStream(new File(tempCaxaPath.replace(".exb", ".xml")));
//					System.out.println("ϴxml:" + tempCaxaPathName.replace(".exb", ".xml"));
//					boolean tempXml = FTPUtils.uploadFile(tempCaxaPathName.replace(".exb", ".xml"), tempXmlPathIn);
//					if (tempXml == false) {
//						return "";
//					}
//					// жǷokerrļ˵ӳɣ
//					System.out.println("okerr");
//					boolean downResult = FTPUtils.downOkOrErrFile(tempCaxaPathName, System.getenv("TEMP"));
//					// ʧܣһftpԱָļtxtshxλãȡʹõȱʡ壩Ȼ󵯳Դλ\ĵ
//					if (downResult == false) {
//						return "";
//					}
//					// ɹ ɾftpϵͬtxt ȴpdf
//					System.out.println("ɾļתpdf" + tempCaxaPathName.replace(".exb", ".txt"));
//					boolean getPdf = FTPUtils.deleteTxt(tempCaxaPathName, System.getenv("TEMP"));
//					if (getPdf) {
//						return tempCaxaPathName;
//					}
//				}
//				return "";
//	}
//
//	
//
	/**
	 * @param caxaDataset
	 * @param openDirect  caxaݼֻģ޸ʱ<=ʱ䣬pdf޸ʱ>ʱ,ֻ򿪣Ҫӳתpdf
	 * @return true = ֱӴ_caxa || false = pdf
	 */
	private boolean isCaxaDatasetRegen(Dataset caxaDataset, boolean openDirect) {
		try {
			List<ModelObject> whereReference = TcUtils.getWhereReference(new WorkspaceObject[] {caxaDataset});
			System.out.println();
			
//			TCComponentItemRevision rev = (TCComponentItemRevision) caxaDataset.getReferenceProperty("item_revision");
//			if (!caxaDataset.okToModify()) {
//				if (debug)
//					System.out.println("ֻ======");
//				boolean isReleased  = caxaDataset.getProperty("release_status_list").length()==0?false:true;
//				if (!isReleased) {
//					//޷״̬
//					openDirect = true;
//				
//				} else {
//					
//					if (debug)
//						System.out.println("жϷʱ");
//					Date date_released = caxaDataset.getTCProperty("date_released").getDateValue();
//					Date last_mod_date = caxaDataset.getTCProperty("last_mod_date").getDateValue();
//					// ʱ֮ķ
//					long diffMinutes = Math.abs((last_mod_date.getTime() - date_released.getTime()) / (60 * 1000));
//					if (diffMinutes < 2) {
//						if (debug)
//							System.out.println("޸ʱͷʱʱ2,PDF");
//						openDirect = false;
//					} else {
//						if (debug)
//							System.out.println("޸ʱͷʱʱ2,PDF");
//						
//						Map<String, String> ecnValueMap = getECNValueMap(rev);
//						
//						if(ecnValueMap.size() != 0) {
//							openDirect = false;
//						}else {
//							openDirect = true;
//						}
//					}
//				}
//				try {
//					//תPDF
//
//					String[] properties = session.getPropertyService().getProperties(rev, new String[] {"fnd0InProcess"});
//
//					if(properties.length != 0 && properties[0]!=null && "true".equals(properties[0])) {
//						openDirect = false;
//					}
//						
//					System.out.println(1);
//				} catch (Exception e) {
//					// TODO Auto-generated catch block
//					e.printStackTrace();
//				}
//
//			} else {
//				if (debug)
//					System.out.println("д======");
//				openDirect = false;
//			}		
//		
//		
//			if(openDirect) {				
//				System.out.println("ǷֱӴͼֽжϽ=True");
//			}else {
//				System.out.println("ֱӴͼֽжϽ=False");
//			}
//			//ر߼TCѡHX_SignCAXAByChoice,ȷûǿת
//	
//			String forceOpenDirect = TcUtils.getTCPreference("HX_SignCAXAByChoice", session,TCPreferenceService.TC_preference_user);
//			if (!forceOpenDirect.isEmpty()) {
//				if (forceOpenDirect.equals("true")) {
//					System.out.println("ǿִǩͼֽ:True");
//					openDirect = false;
//				} else if (forceOpenDirect.equals("false")) {
//					System.out.println("ǿִǩͼֽ:False");
//					openDirect = true;
//				} else {
//					System.out.println("ǿִǩͼֽ:");
//				}
//			}
//			
//			//2023/05/26 HXCװͼתPDF
//			if(rev!=null) {
//				if("HXC".equals(FTPUtils.CompanyName) && "Hxc8gztuzhiRevision".equals(rev.getType())) {
//					openDirect = true;
//				}
//			}else{
//				openDirect = true;
//			}
		} catch (Exception e) {
			e.printStackTrace();
//			MessageBox.post("Teamcenter쳣"+e.getMessage(), "", MessageBox.ERROR);
		} 
		return openDirect;
	}
//
//	private Map<String, String> getECNValueMap(TCComponent rev) throws TCException {
//		// 2019.11.254ӳ䣺İΣ汾ţļţ֪ͨıţǩ֣ϹԱڣ֪ͨڣգ
//		// ֻһθļ¼
//		String dateString = "";
//		Map<String, String> valueMap = new HashMap<String,String>();
//		AIFComponentContext[] ecr = rev.whereReferenced();
//		for (int i = 0; i < ecr.length; i++) {
//			TCComponent ecrRev = (TCComponent) ecr[i].getComponent();
//			System.out.println("ecrRev.getProperty:" + ecrRev.getProperty("object_type"));
//			if (ecrRev.getProperty("object_type").equals("GCGGTZD Revision")) {
//				// 뷢
//				if (ecrRev.getProperty("release_status_list").length() > 0) {
//					String dateString2 = ecrRev.getProperty("creation_date");
//					String revType = rev.getProperty("object_type");
//					System.out.println("revType:" + revType);
//					if (dateString.length() == 0) {
//						dateString = dateString2;
//						if (revType.equals("ZPT Revision") || revType.equals("LJT Revision")
//								|| revType.equals("WXT Revision")) {
//
//							valueMap.put("İ1", rev.getProperty("item_revision_id"));
//							valueMap.put("ļ1", ecrRev.getProperty("item_id"));
//							valueMap.put("ǩ1", "ϹԱ");
//							valueMap.put("1", ecrRev.getProperty("creation_date").split(" ")[0]);
//						} else if (revType.equals("GYT Revision")) {
//							valueMap.put("İ", rev.getProperty("item_revision_id"));
//							valueMap.put("ļ", ecrRev.getProperty("item_id"));
//							valueMap.put("ǩ", "ϹԱ");
//							valueMap.put("", ecrRev.getProperty("creation_date").split(" ")[0]);
//
//						}
//					} else {
//						if (dateString.compareTo(dateString2) < 0) {
//							dateString = dateString2;
//							if (revType.equals("ZPT Revision") || revType.equals("LJT Revision")
//									|| revType.equals("WXT Revision")) {
//
//								valueMap.put("İ1", rev.getProperty("item_revision_id"));
//								valueMap.put("ļ1", ecrRev.getProperty("item_id"));
//								valueMap.put("ǩ1", "ϹԱ");
//								valueMap.put("1", ecrRev.getProperty("creation_date").split(" ")[0]);
//							} else if (revType.equals("GYT Revision")) {
//								valueMap.put("İ", rev.getProperty("item_revision_id"));
//								valueMap.put("ļ", ecrRev.getProperty("item_id"));
//								valueMap.put("ǩ", "ϹԱ");
//								valueMap.put("", ecrRev.getProperty("creation_date").split(" ")[0]);
//
//							}
//						}
//					}
//				}
//
//			}
//		}
//		return valueMap;
//		
//	}
//
//	// ȡеȴpdfתʱʱ
//	private void loadWaitPdf() {
//		Properties properties = new Properties();
//		InputStream is = null;
//		is = getClass().getResourceAsStream("PDFInfo.properties");
//		try {
//			properties.load(is);
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//			MessageBox.post("PDFInfo.properties ȡ쳣"+e.getMessage(), "", MessageBox.ERROR);
//		}
//		waitPdf = Integer.valueOf(properties.getProperty("WAITPDF"));
//	}
//
//	/**
//	 * ȴļ
//	 * @param file 
//	 */
//	public void second(File file) {
//		if (!file.exists()) {
//			System.out.println("second");
//			try {
//				Thread.sleep(200);
//				second(file);
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//				MessageBox.post("쳣"+e.getMessage(), "", MessageBox.ERROR);
//			}
//		} else {
//			System.out.println("cunzai");
//			try {
//				Thread.sleep(200);
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//				MessageBox.post("쳣"+e.getMessage(), "", MessageBox.ERROR);
//			}
//		}
//	}
//
//	
//	/**
//	 * xmlӳļ
//	 * @param caxaDataset 
//	 * @param tcp 
//	 * @param xmlName
//	 * @return
//	 * @throws Exception
//	 */
//	public boolean hx_SetCAXAFile2(TCComponentDataset caxaDataset, TCPreferenceService tcp, String xmlName)
//			throws Exception {
//		TCComponentItemRevision rev = (TCComponentItemRevision) caxaDataset.getReferenceProperty("item_revision");
//		TCComponentForm revForm = (TCComponentForm) (rev.getReferenceListProperty("IMAN_master_form_rev"))[0];
//		TCComponentItem item = rev.getItem();
//		if (caxaDataset == null || rev == null || revForm == null || rev == null || item == null || refValues == null
//				|| refValues.length == 0) {
//			return false;
//		}
//		File file = new File(System.getenv("TEMP") + "\\" + xmlName + ".xml");
//		Map<String, String> valueMap = new HashMap<String, String>();
//		String propName;
//		int index;
//		for (String refValue : refValues) {
//			String[] valueS = refValue.split("=");
//
//			String value = null;
//			if (valueS == null || valueS.length != 2) {
//				continue;
//			}
//			String[] propNameS = valueS[1].split("\\.");
//			if (propNameS == null || propNameS.length != 2) {
//				continue;
//			}
//			index = valueS[0].indexOf(':');
//			propName = valueS[0].substring(index + 1).trim();
//			switch (propNameS[0].toUpperCase()) {
//			case "ITEM":
//				value = TcUtils.hx_GetProp(item, propNameS[1]);
//
//				break;
//			case "REV":
//				value = TcUtils.hx_GetProp(rev, propNameS[1]);
//				break;
//			case "REVMASTER":
//				value = TcUtils.hx_GetProp(revForm, propNameS[1]);
//				break;
//			case "ITEMMASTER":
//				break;
//			default:
//				break;
//			}
//			if (value == null || (valueMap.containsKey(propName) && value.length() == 0))
//				continue;
//			valueMap.put(propName, value);
//		}
//		if (valueMap.size() != 0) {
//			writeDoc(valueMap, file, xmlName);
//			return true;
//		}else {
//			return false;
//		}
//		
//
//	}
//
//	
//	
//	
//
//	public void replaceOrcreate(TCComponentDataset arg0, TCComponentItemRevision rev, TCSession session,
//			String addPdfPath) throws Exception {
//		// жϰ汾pdfݼƺcaxaͬо滻ûо½
//		TCComponentDataset dataset = null;
//		TCComponent[] datasets = (TCComponent[]) rev.getTCProperty("IMAN_specification").getReferenceValueArray();
////		datasets=(TCComponent[]) tempRev.getTCProperty("TC_Attaches").getReferenceValueArray();
//			String pdfName = "";
//			String caxaName = "";
//			for (int i = 0; i < datasets.length; i++) {
//				if (datasets[i].getProperty("object_type").equals("PDF")) {
//					pdfName = datasets[i].getProperty("object_name");
//					caxaName = arg0.getProperty("object_name");
//					if (pdfName.contains(".pdf") && caxaName.contains(".exb")) {
//						pdfName = pdfName.substring(0, pdfName.lastIndexOf(".pdf"));
////						System.out.println(pdfName);
//						caxaName = caxaName.substring(0, caxaName.lastIndexOf(".exb"));
////						System.out.println(pdfName);
//					}
//				}
//				if (datasets[i].getProperty("object_type").equals("PDF") && caxaName.equals(pdfName)) {
//					dataset = (TCComponentDataset) datasets[i];
//				}
//			}
//
//		if (dataset == null) {
//			
//			
//			try {
//				TCComponentDatasetType datasetType = (TCComponentDatasetType) session.getTypeComponent("Dataset");
//				dataset = datasetType.create(arg0.getProperty("object_name").replace(".exb", ".pdf"), "", "PDF");
//				rev.add("IMAN_specification", dataset);
//			} catch (TCException e) {
//				e.printStackTrace();
//				ChangeDbomUtil.setByPass(false);
//				MessageBox.post("Teamcenter쳣"+e.getMessage(), "", MessageBox.ERROR);
//				 
//			}
//		 
//		}
//		if (dataset == null) {
//			MessageBox.post("ʧ", "", MessageBox.ERROR);
//		}
//		try {
//			dataset.setFiles(new String[] { addPdfPath }, new String[] { "PDF_Reference" });
//			dataset.save();
//			arg0.setProperty("object_desc", "תʱ䣺"+new SimpleDateFormat("yyyy-MM-dd HH:mm").format(new Date()));
//		} catch (Exception e) {
//			TCComponentItemRevision tempRev = null;
//			// õǰݼڰ汾
//			try {
//				tempRev = (TCComponentItemRevision) dataset.getReferenceProperty("item_revision");
//			
//			//String message = tempRev.getProperty("object_string") + "PDFͼֽӦ滻ʧܣϵԱ";
//			//޸⣺ֻģʽͼֽݼеıʾ쳣by Jimmy
//			//ifError(tempRev, message);
//				System.out.println("滻pdfʧܣ·");
//			} catch (TCException e1) {
//				ChangeDbomUtil.setByPass(false);
//				e1.printStackTrace();
//				MessageBox.post("Teamcenter쳣"+e1.getMessage(), "", MessageBox.ERROR);
//			}
//		}
//
//		ChangeDbomUtil.setByPass(false);
//	 
//
//	}
//
//	
//	
//	
//	
//
//	/**
//	 * ȡPDFĳߴͼƥ䲢ҪͼƬλ
//	 * 
//	 * @param rectangle
//	 * @return
//	 */
//	public Float[] getSize(Rectangle rectangle) {
//		Float[] sizef = new Float[2];
//		float toleft = rectangle.getLeft();
//		float tobottom = rectangle.getBottom();
//		float toright = rectangle.getRight();
//		float totop = rectangle.getTop();
//
//		JFomPdfBean bean = new JFomPdfBean();
//		bean.setH(toright - toleft);// PDFĿ
//		bean.setW(totop - tobottom);// PDFĸ
//		sizef[0] = bean.getH();
//		sizef[1] = bean.getW();
//		System.out.println("bean.getH------------>" + bean.getH());
//		System.out.println("bean.getW------------>" + bean.getW());
//
//		return sizef;
//	}
//
//	public String[] selectType(String Ax, String designType) {
//		String[] type = null;
//		switch (designType) {
//
//		case "HX3_GYTRevision":// ͼ
//			if (Ax.equals("A3")) {
//				type = new String[1];
//				type[0] = Ax + "_GY";
//			} else if (Ax.equals("A2")) {
//				type = new String[2];
//				type[0] = Ax + "_GY1";
//				type[1] = Ax + "_GY2";
//			}
//			break;
//		case "HX3_TYGY1Revision":// ͨù
//			if (Ax.equals("A3")) {
//				type = new String[1];
//				type[0] = Ax + "_TYGY";
//			} else if (Ax.equals("A2")) {
//				type = new String[2];
//				type[0] = Ax + "_TYGY1";
//				type[1] = Ax + "_TYGY2";
//			}
//			break;
//		case "HX3_WXTRevision":// ƷͼЭӹͼHX3_WXTRevision ͼHX3_LJTRevision װͼHX3_ZPTRevision
//			type = new String[1];
//			type[0] = Ax + "_PRODUCT";
//			break;
//		case "HX3_DJTRevision":// ƷͼЭӹͼHX3_WXTRevision ͼHX3_LJTRevision
//								// װͼHX3_ZPTRevisionͼͼHX3_DJTRevision
//			type = new String[1];
//			type[0] = Ax + "_PRODUCT";
//			break;
//		case "HX3_LJTRevision":// ƷͼЭӹͼHX3_WXTRevision ͼHX3_LJTRevision װͼHX3_ZPTRevision
//			type = new String[1];
//			type[0] = Ax + "_PRODUCT";
//			break;
//		case "HX3_ZPTRevision":// ƷͼЭӹͼHX3_WXTRevision ͼHX3_LJTRevision װͼHX3_ZPTRevision
//			type = new String[1];
//			type[0] = Ax + "_PRODUCT";
//			break;
//		case "HX3_GCGGTZDRevision":// ̸֪ͨ
//			type = new String[1];
//			type[0] = Ax + "_ECN";
//			break;
//		case "HX3_GZTRevision":// װͼ
//			type = new String[2];
//			type[0] = Ax + "_GZT1";
//			type[1] = Ax + "_GZT2";
//			break;
//		default:
//			break;
//		}
//
//		return type;
//	}
//
//	public Image[] setPic(Image[] img, String[] sizeType, Properties properties, String markImagePath)
//			throws BadElementException, MalformedURLException, IOException {
//		// תString·
//		img = new Image[sizeType.length];
//		for (int k = 0; k < sizeType.length; k++) {
//
//			img[k] = Image.getInstance(markImagePath);// ȡͼƬʵ
//			String str = properties.getProperty(sizeType[k]);
//			if (str == null) {
//				img[k].setAbsolutePosition(Float.valueOf(10), Float.valueOf(10));
//			} else {
//
//				String[] values = str.split(",");
//				img[k].setAbsolutePosition(Float.valueOf(values[0]), Float.valueOf(values[1]));// ˮӡ½ǵ
//			}
//		}
//		return img;
//	}
//
//	public void addPdfMark(String InPdfFile, String temp, String[] markImagePath, String designType) throws Exception {
//		boolean isModel = true;
//		File pdffile = new File(temp);
//		if (pdffile.exists()) {
//			pdffile.delete();
//		}
//		// 
//		Properties properties = new Properties();
//		InputStream is = null;
//		is = getClass().getResourceAsStream("PDFInfo.properties");
//		properties.load(is);
//
//		// PDF ļ
//		PdfReader reader = new PdfReader(InPdfFile, "PDF".getBytes());
//		// PDF ļ
//		PdfStamper stamp = new PdfStamper(reader, new FileOutputStream(temp));
//		// ˮӡͼƬ
//		Image[] img = null;
//		for (int j = 0; j < markImagePath.length; j++) {
////			img.scaleAbsolute(35, 20);// ͼƬ
////			float imgW = img.getScaledWidth();// ȡͼƬĿ
////			float imgH = img.getScaledHeight();// ȡͼƬĸ߶
//			// ȡPDFҳ
//			int pageSize = reader.getNumberOfPages();// ȡļҳ
//			for (int i = 1; i <= pageSize; i++) {
//				Rectangle rectangle = reader.getPageSize(i);
//				Float[] fposition = getSize(rectangle);
//				System.out.println("fposition[0]=======" + fposition[0]);
//				System.out.println("fposition[1]=======" + fposition[1]);
//				boolean isSizeOk = false;
//				String[] sizeType = null;
//				// ˮӡĲλA0
//				if ((fposition[0] > 3300 && fposition[1] > 2300)) {
//					isSizeOk = true;
//					// ͨpdfڵİ汾ж
//					System.out.println("ˮӡĲλA0");
//					sizeType = selectType("A0", designType);
//
//				}
//				// TODO ˮӡĲλA1
//				if ((fposition[0] > 2300 && fposition[1] > 1600) && isSizeOk == false) {
//					isSizeOk = true;
//					System.out.println("ˮӡĲλA1");
//					sizeType = selectType("A1", designType);
//				}
//
//				// TODO ˮӡĲλA2
//				if ((fposition[1] > 1100 && fposition[0] > 1600) && isSizeOk == false) {
//					isSizeOk = true;
//					System.out.println("ˮӡĲλA2");
//					sizeType = selectType("A2", designType);
//				}
//				// TODO ˮӡĲλA2
//				if ((fposition[0] > 1100 && fposition[1] > 1600) && isSizeOk == false) {
//					isSizeOk = true;
//					System.out.println("ˮӡĲλA2_GY");
//					sizeType = selectType("A2", designType);
//				}
//				// TODO ˮӡĲλA3
//				if ((fposition[0] > 1100 && fposition[1] > 800) && isSizeOk == false) {
//					isSizeOk = true;
//					System.out.println("ˮӡĲλA3");
//					sizeType = selectType("A3", designType);
//				}
//
//				// TODO ˮӡĲλA3 
//				if ((fposition[1] > 1100 && fposition[0] > 800) && isSizeOk == false) {
//					isSizeOk = true;
//					System.out.println("ˮӡĲλA3H");
//					sizeType = selectType("A3H", designType);
//				}
//				
//				// TODO ˮӡĲλA4
//				if ((fposition[1] > 800 && fposition[0] > 500) && isSizeOk == false) {
//					isSizeOk = true;
//					System.out.println("ˮӡĲλA4");
//					sizeType = selectType("A4", designType);
//				}
//				
//				// ˮӡĲλA4 
//				if ((fposition[0] > 800 && fposition[1] > 500) && isSizeOk == false) {
//					isSizeOk = true;
//					System.out.println("ˮӡĲλA4H ");
//					sizeType = selectType("A4H", designType);
//				}
//				if (sizeType != null) {
//
//					img = setPic(img, sizeType, properties, markImagePath[j]);
//				}
//				if (img == null || sizeType == null) {
//					img = new Image[1];
//					img[0] = Image.getInstance(markImagePath[j]);// ȡͼƬʵ
//					img[0].setAbsolutePosition(Float.valueOf(10), Float.valueOf(10));
//					/*
//					 * isModel=false; continue;
//					 */
//				}
//				// PDFļвˮӡ
//				PdfContentByte under = stamp.getOverContent(i);// stamp.getUnderContent(i);
//				PdfGState gs = new PdfGState();
//				gs.setFillOpacity(1.0f);// ͸Ϊ0.2
//				under.setGState(gs);
//				for (int k = 0; k < img.length; k++) {
//					under.addImage(img[k]);
//
//				}
//			}
//		}
//		stamp.close();// ر
//		reader.close();// ر
//		File tempfile = new File(InPdfFile);
//		if (tempfile.exists() && isModel == true) {
//			// ɾԭļ
//			tempfile.delete();
//		}
//
//	}
//
//	
//	
//	
//	
//
//	
//	
//	
//	
//
//
//	
//
//	
//
//
//
//	/**
//	 * жݼǷΪģļ
//	 * @param tccomponentdataset
//	 * @return
//	 */
//	public int judgeModel(TCComponentDataset tccomponentdataset) {
//		// жǲľļǾ˳
//		long start1 = System.currentTimeMillis();
//		try {
//			TCComponentItemRevision rev = (TCComponentItemRevision) tccomponentdataset
//					.getReferenceProperty("item_revision");
//			if (rev != null) {
//				TCComponentItem item = rev.getItem();
//				AIFComponentContext[] folders = item.whereReferenced();
//				if (folders.length == 1) {
//					if (folders[0].getComponent() instanceof TCComponentFolder) {
//
//						TCComponentFolder folder = (TCComponentFolder) folders[0].getComponent();
//						AIFComponentContext[] folders2 = folder.whereReferenced();
//						if (folders2.length == 1) {
//							if (folders2[0].getComponent() instanceof TCComponentFolder) {
//								TCComponentFolder folder2 = (TCComponentFolder) folders2[0].getComponent();
//								String name = folder2.getProperty("object_name");
//								if (name.equals("ͼֽģ")) {
//									return 1;
//								}
//							}
//						}
//					}
//				}
//			} else {
//				return 0;
//			}
//		} catch (TCException e1) {
//			e1.printStackTrace();
//			MessageBox.post("Teamcenter쳣"+e1.getMessage(), "", MessageBox.ERROR);
//		} //
//		long now1 = System.currentTimeMillis();
//		float time1 = (now1 - start1) / 1000.00f;
//		System.out.println("judgeModelѺʱ" + time1 + "");
//		return 0;
//	}
//
//	
//
//
//	
//	/**
//	 * ЭCAXAݼǰ
//	 * 
//	 * @param caxaDataset
//	 * @throws Exception 
//	 */
//	public void hx_SetCAXAFileOrigin(TCComponentDataset caxaDataset, TCPreferenceService tcp, String type,boolean openDirect)
//			throws Exception {
//		long start1 = System.currentTimeMillis();
//		
//		// õǰݼڰ汾󡢰汾
//		TCComponentItemRevision rev = (TCComponentItemRevision) caxaDataset.getReferenceProperty("item_revision");
//		System.out.println("-----------" + rev.getProperty("object_string"));
//		TCComponentForm revForm = (TCComponentForm) (rev.getReferenceListProperty("IMAN_master_form_rev"))[0];
//		TCComponentItem item = rev.getItem();
//		// ȡcaxaļ
//		File file = TcUtils.getCaxaDatasetFile(caxaDataset);
//		if (rev == null || revForm == null || item == null || file == null || refValues == null
//				|| refValues.length == 0) {
//			return;
//		}
//
//		Map<String, String> valueMap = getValueMap(item, rev, revForm, openDirect);
//		if (valueMap.size() != 0) {
//			writeDoc(valueMap, file,null);
//		} 
//		long now1 = System.currentTimeMillis();
//		float time1 = (now1 - start1) / 1000.00f;
//		System.out.println("hx_SetCAXAFileѺʱ" + time1 + "");
//	}
//
//
//
//	private Map<String, String> getValueMap(TCComponent item,TCComponent rev,TCComponent revForm,boolean openDirect ) throws TCException {
//		Map<String, String> valueMap = new HashMap<String,String>();
//		StringBuffer infoSB = new StringBuffer();
//		String propName;
//		int index;
//		for (String refValue : refValues) {
//			String[] valueS = refValue.split("=");
//
//			String value = null;
//			if (valueS == null || valueS.length != 2) {
//				continue;
//			}
//			String[] propNameS = valueS[1].split("\\.");
//			if (propNameS == null || propNameS.length != 2) {
//				continue;
//			}
//			index = valueS[0].indexOf(':');
//			propName = valueS[0].substring(index + 1).trim();
//			switch (propNameS[0].toUpperCase()) {
//			case "ITEM":
//				value = TcUtils.hx_GetProp(item, propNameS[1]);
//				break;
//			case "REV":
//				value = TcUtils.hx_GetProp(rev, propNameS[1]);
//				break;
//			case "REVMASTER":
//				value = TcUtils.hx_GetProp(revForm, propNameS[1]);
//				break;
//			case "ITEMMASTER":
//				break;
//			default:
//				break;
//			}
//			if (value == null || (valueMap.containsKey(propName) && value.length() == 0))
//				continue;
//			valueMap.put(propName, value);
//			infoSB.append(valueS[0]).append("=").append(value).append("|");
//		}
//		Map<String, String> ecnValueMap = getECNValueMap(rev);
//		for(String ecnValueSet :ecnValueMap.keySet()) {
//			valueMap.put(ecnValueSet, ecnValueMap.get(ecnValueSet));
//		}
//		
//		valueMap.put("Ƿǩ",openDirect==true?"":"");
//		System.out.println("valueMap:" + valueMap);
//		return valueMap;
//	}
//
//	
//
//	/**
//	 * дӳļ
//	 * @param valueMap ӳԼ
//	 * @param file xmlӳļ
//	 * @throws Exception
//	 */
//	private void writeDoc(Map<String,String> valueMap,File file,String caxaFileName) throws Exception {
//		SAXReader reader = new SAXReader();
//		Document doc = reader.read(new File(exePath + "sign.xml"));
//		Element root = doc.getRootElement();
//		Element title = root.element("SignInfo").element("Title");
//		Element files = root.element("SignInfo").element("Files").element("File");
//		if(caxaFileName != null) {
//			files.attribute("Path").setValue(FTPUtils.ftpPath +"\\"+ caxaFileName + ".exb");
//		}
//		Element e;
//		Iterator it = title.elementIterator();
//		while (it.hasNext()) {
//			e = (Element) it.next();
//			String val = valueMap.get(e.attribute("Name").getValue());
//			if(debug)System.out.println("name:" + e.attribute("Name").getValue());
//			if(debug)System.out.println("val:" + val);
//			if (val != null)
//				e.attribute("Value").setValue(val);
//		}
//		PrintWriter pw = new PrintWriter(file, "UTF-8");
//		doc.write(pw);
//		pw.close();
//		System.out.println("222");
//
//	}
//
//
//	
//	
//
//	public void openCad() {
//		
//		String path = this.getClass().getProtectionDomain().getCodeSource().getLocation().getPath();
////		System.out.println("·-----------------"+path);
//		String exePath = path.substring(1, path.indexOf("com.connor.signoff")).replace("/", "\\");
//		exePath = exePath + "CADregedit.bat";
//		File file = new File(exePath);
//
//		if (file != null && file.exists()) {
//			System.out.println("ִдCAXAɹע޸:"+ exePath);
//			Runtime rn = Runtime.getRuntime();
//			Process p = null;
//			try {
//				System.out.println("CALL CMD:" + exePath);
//				p = rn.exec("cmd /c \"" + exePath + "\"");
//				p.waitFor();
//				//滻ΪԱ
//				//String command = "cmd /c start /wait runas /user:Administrator \"cmd /c \"" + exePath + "\"\"";
//				//Runtime.getRuntime().exec(command);
//			} catch (Exception e) {
//				e.printStackTrace();
//				System.out.println("Error exec!");
//			}
//		} else {
//			System.out.println("" + exePath + "ļ");
//		}
//		
//		
//	}

	

}
