package com.connor.signoff.soa.handler;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.InvocationTargetException;
import java.net.MalformedURLException;
import java.net.SocketException;
import java.net.URISyntaxException;
import java.net.URLDecoder;
import java.nio.file.Files;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.concurrent.TimeoutException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.net.ftp.FTPFile;
import org.apache.commons.net.ftp.FTPReply;
import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;
import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;
import com.itextpdf.text.BadElementException;
import com.itextpdf.text.Image;
import com.itextpdf.text.Rectangle;
import com.itextpdf.text.pdf.PdfContentByte;
import com.itextpdf.text.pdf.PdfGState;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.PdfStamper;
import com.teamcenter.clientx.AppXSession;
import com.teamcenter.services.strong.administration.PreferenceManagementService;
import com.teamcenter.services.strong.administration._2012_09.PreferenceManagement;
//import com.teamcenter.services.strong.administration._2012_09.PreferenceManagement;
import com.teamcenter.services.strong.administration.*;
import com.teamcenter.services.strong.core.DataManagementService;
import com.teamcenter.services.strong.core.SessionService;
import com.teamcenter.services.strong.core._2006_03.DataManagement.CreateDatasetsResponse;
import com.teamcenter.services.loose.core._2006_03.FileManagement;
import com.teamcenter.soa.client.FileManagementUtility;
import com.teamcenter.soa.client.GetFileResponse;
import com.teamcenter.soa.client.model.ModelObject;
import com.teamcenter.soa.client.model.Property;
import com.teamcenter.soa.client.model.ServiceData;
import com.teamcenter.soa.client.model.strong.Dataset;
import com.teamcenter.soa.client.model.strong.ImanFile;
import com.teamcenter.soa.client.model.strong.Item;
import com.teamcenter.soa.client.model.strong.ItemRevision;
import com.teamcenter.soa.client.model.strong.POM_system_class;
import com.teamcenter.soa.client.model.strong.ReleaseStatus;
import com.teamcenter.soa.client.model.strong.User;
import com.teamcenter.soa.client.model.strong.WorkspaceObject;
import com.teamcenter.soa.exceptions.NotLoadedException;
import com.teamcenter.services.strong.workflow._2007_06.Workflow.ReleaseStatusInput;
import com.teamcenter.services.strong.workflow._2007_06.Workflow.ReleaseStatusOption;
import com.teamcenter.services.strong.workflow._2007_06.Workflow.SetReleaseStatusResponse;
import com.teamcenter.services.strong.workflow.WorkflowService;
import com.teamcenter.services.strong.core._2007_01.DataManagement;
import com.teamcenter.services.strong.core._2007_01.Session;
public class caxaPropertyHandler {

	public static boolean debug = true;
	private static String fileName;
	private static FTPClient ftpClient = null;
	private static String exePath;//·
	private static String[] refValues;//ӳ
	private static AppXSession session;
//	InterfaceAIFComponent[] targetComp;
	private static String caxaInfo = "";
	private static Logger logger = null;
	private static int waitPdf = 0;

	private static String releaseStatus;
	
	private static DataManagementService dmService;
	private static FileManagementUtility fmu;
	private static PreferenceManagementService tcp;
	
	private static boolean hasException = true;
	private static String companyName;
	private static String mainArgs[];
//	private static Stirng re
	/**
	 * strERR = ""
	 */
//	private static String strERR = "";
//
//	/**
//	 * 
//	 */
//	private static int monitorWorkCount = 0;
//
//	public String traverseFolder(String path) {
//
//		File file = new File(path);
//		if (file.exists()) {
//			File[] files = file.listFiles();
//			if (null == files || files.length == 0) {
//				if (debug)
//					System.out.println("ļǿյ!");
//
//			} else {
//				for (File file2 : files) {
//					if (file2.isDirectory()) {
//					} else {
//						if (file2.getAbsolutePath().toLowerCase().endsWith(".exb")) {
//							if (debug)
//								System.out.println("ļ:" + file2.getAbsolutePath());
//							return file2.getAbsolutePath();
//						}
//
//					}
//				}
//			}
//		} else {
//			if (debug)
//				System.out.println("ļ!");
//		}
//		return "";
//
//	}
	/**
	 * GBKļתΪISOʽ
	 * һwinϵͳϴļFTP
	 * @param fileNameGBK
	 * @return
	 */
	public static String convGBKtoISO(String fileNameGBK) {
		String filenameISO="";
		try {
			filenameISO = new String(fileNameGBK.getBytes("GBK"),"iso-8859-1");
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return filenameISO;		
	}
//	
	/**
	 * ISOļתΪGBKʽ
	 * һFTPļwinϵͳ
	 * @param fileNameGBK
	 * @return
	 */
	public static String convISOtoGBK(String fileNameISO) {
		String filenameGBK="";
		try {
			filenameGBK = new String(fileNameISO.getBytes("iso-8859-1"),"GBK");
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return filenameGBK;		
	}
//
	/**
	 * ļ
	 * @param ref_list 
	 * @param fileOgiginName 
	 * 
	 * @param comps
	 * @return
	 * @throws TCException
	 * @throws IOException
	 */
	public static String downLoadCaxaFile(File ref_list, String fileOgiginName, Dataset comp, ItemRevision rev) {
		if (comp == null) {
			return "";
		}
		String value = "";
		String tempPath = System.getenv("TEMP");
		// MessageBox.post(" tempPath =
		// "+tempPath,"INFO",MessageBox.INFORMATION);
		if (tempPath == null) {
			tempPath = "";
		} else if (!tempPath.endsWith("\\")) {
			tempPath = tempPath + "\\";
		}
		SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmssSSS");
		// for(TCComponent comp : comps){
		try {
//			if (comp instanceof Dataset) {
//				ModelObject[] objects = {comp};
//	            dmService.refreshObjects(objects);
//	            dmService.getProperties(objects, new String[]{"ref_list"});
//	            objects = comp.get_ref_list();
//
//	            GetFileResponse getFileResponse = fmu.getFiles(objects);
//	            File[] tcFiles = getFileResponse.getFiles();
////				TCComponentTcFile[] tcFiles = ((TCComponentDataset) comp).getTcFiles();
//				File file = null;
////				if(debug)System.out.println("tcFiles:" + tcFiles.length);
//				if (tcFiles != null && tcFiles.length != 0) {
//					file = tcFiles[0];
					dmService.getProperties(new ModelObject[] {rev}, new String[] {"item_id","item_revision_id"});
					String fileName = fileOgiginName;
//					if(debug)System.out.println("fileName:" + fileName);
					String fileDix = fileName.substring(fileName.lastIndexOf("."), fileName.length());
					String item_id = rev.getPropertyDisplayableValue("item_id");
					String item_revision_id = rev.getPropertyDisplayableValue("item_revision_id");
					String fileRealName =item_id + "-" + item_revision_id + sdf.format(new Date()) + fileDix;
					Pattern pattern = Pattern.compile("[\\s\\\\/:\\*\\?\\\"<>\\|]");
			        Matcher matcher = pattern.matcher(fileRealName);

			        fileRealName= matcher.replaceAll(""); // ƥ䵽ķǷַԿ滻
					
					fileName = tempPath +fileRealName;
					
					File newFile = new File(fileName);
					ref_list.renameTo(newFile);
//
//					File.copyFile(ref_list, dirFile);
//
//					if (debug)
//						System.out.println("111111111111");
					return fileName;
//				}
//			}
		} catch (Exception e) {
			e.printStackTrace();
		} 
		// }
		return value;
	}
//
//	/**
//	 * ļ
//	 * 
//	 * @param comps
//	 * @return
//	 * @throws TCException
//	 * @throws IOException
//	 */
//	public String downLoadFile(TCComponent comp) {
//		if (comp == null) {
//			return "";
//		}
//		String value = "";
//		String tempPath = System.getenv("TEMP");
//		// MessageBox.post(" tempPath =
//		// "+tempPath,"INFO",MessageBox.INFORMATION);
//		if (tempPath == null) {
//			tempPath = "";
//		} else if (!tempPath.endsWith("\\")) {
//			tempPath = tempPath + "\\";
//		}
//		SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmssSSS");
//		// for(TCComponent comp : comps){
//		try {
//			if (comp instanceof TCComponentDataset) {
//				TCComponentTcFile[] tcFiles = ((TCComponentDataset) comp).getTcFiles();
//				File file = null;
////				if(debug)System.out.println("tcFiles:" + tcFiles.length);
//				if (tcFiles != null && tcFiles.length != 0) {
//					file = tcFiles[0].getFmsFile();
//					String fileName = file.getName();
////					if(debug)System.out.println("fileName:" + fileName);
//					String fileDix = fileName.substring(fileName.lastIndexOf("."), fileName.length());
//					fileName = tempPath + sdf.format(new Date()) + fileDix;
//					File dirFile = new File(fileName);
//
//					FileUtility.copyFile(file, dirFile);
//
//					if (debug)
//						System.out.println("11111111111");
//					return fileName;
//				}
//			}
//		} catch (TCException e) {
//			e.printStackTrace();
//		} catch (IOException e) {
//			e.printStackTrace();
//		}
//		// }
//		return value;
//	}
//
	public static void caxaToPdf(Dataset component) throws Exception {
//		int messageCount=getMessage();
//		if(debug)System.out.println("ǰŶ===="+messageCount);
//		property(component);
	}

	public static void property(Dataset dataset,ItemRevision rev) {
		String workDir = System.getenv("TEMP") + File.separator + "caxaBatch";
		File workDirFile = new File(workDir);
		if (!workDirFile.exists()) {
			workDirFile.mkdirs();
		}

		try {			
				String fileOgiginName = "";
			    ModelObject[] tempObjects = {dataset};
	            dmService.refreshObjects(tempObjects);
	            dmService.getProperties(tempObjects, new String[]{"ref_list"});
	            tempObjects = dataset.get_ref_list();
	            
	            ModelObject exbRefFile = null;
				dmService.getProperties(tempObjects, new String[]{"original_file_name","file_ext"});
				for(int i = 0;i < tempObjects.length;i++) {
					fileOgiginName = tempObjects[i].getPropertyObject("original_file_name").getStringValue();
					String refExtString = tempObjects[i].getPropertyObject("file_ext").getStringValue();
					
					if(refExtString.toLowerCase().equals("exb")) {
						exbRefFile = tempObjects[i];
						break;
					}
				}
				tempObjects = new ModelObject[] {exbRefFile};

	            GetFileResponse getFileResponse = fmu.getFiles(tempObjects);
	            File[] ref_lists = getFileResponse.getFiles();
			
	            
				if (ref_lists.length == 0) {
					caxaInfo = caxaInfo + ";" + "caxaʧ,û";//:id" + item_id + "  汾" + item_rev_id;
					return;
				}
				File exbFile1 = ref_lists[0];
				
				if (exbFile1 == null) {
					caxaInfo = caxaInfo + ";" + "ûҵexbļ";//:id" + item_id + "  汾" + item_rev_id;
					return;
				}
					
					
					
					
					// TODO Ⱥϴcaxaxmlļftpת
					String tempCaxaPath = "";

					tempCaxaPath = downLoadCaxaFile(exbFile1,fileOgiginName,dataset, rev);// ļtemp·£Ϊǰʱ
//
					// пΪգ粻õʱ
					if (tempCaxaPath.trim().length() == 0) {
						caxaInfo = caxaInfo + ";" + "caxaʧ";//:id" + item_id + "  汾" + item_rev_id;
						return;
					}

					File file = new File(tempCaxaPath);

					String tempCaxaPathName = tempCaxaPath.substring(tempCaxaPath.lastIndexOf("\\") + 1);
					second(new File(tempCaxaPath));
					FileInputStream tempCaxaPathIn = null;

					try {
						tempCaxaPathIn = new FileInputStream(new File(tempCaxaPath));

					} catch (FileNotFoundException e) {
						e.printStackTrace();
					}
					if (debug)
						System.out.println("ʼϴcaxa");
					boolean tempCaxa = uploadFile(FTPUtils.ftpHost, FTPUtils.ftpUserName, FTPUtils.ftpPassword, FTPUtils.ftpPort, FTPUtils.ftpPath, tempCaxaPathName, tempCaxaPathIn);
					if (tempCaxa == false) {

						caxaInfo = caxaInfo + ";" + "caxaϴʧ";//:id" + item_id + "  汾" + item_rev_id;
						if (debug)
							System.out.println("upload fail----------------");
						return;
					}

					boolean jump = hx_SetCAXAFile(dataset,
							tempCaxaPathName.substring(0, tempCaxaPathName.length() - 4),fileOgiginName,rev);
					if (jump == false) {
						return;
					}
					second(new File(tempCaxaPath.replace(".exb", ".xml")));
					FileInputStream tempXmlPathIn = null;
					try {
						tempXmlPathIn = new FileInputStream(new File(tempCaxaPath.replace(".exb", ".xml")));

					} catch (FileNotFoundException e) {
						e.printStackTrace();
					}
					if (debug)
						System.out.println("ϴxml");
					boolean tempXml = uploadFile(FTPUtils.ftpHost, FTPUtils.ftpUserName, FTPUtils.ftpPassword, FTPUtils.ftpPort, FTPUtils.ftpPath,
							tempCaxaPathName.replace(".exb", ".xml"), tempXmlPathIn);
					if (tempXml == false) {
						caxaInfo = caxaInfo + ";" + "xmlϴʧ";//:id" + item_id + "  汾" + item_rev_id;
						return;
					}
//
					// жǷokerrļ˵ӳɣ
					if (debug)
						System.out.println("okerr");
					waitOkOrErrFileCount = 0;
					boolean downResult = downOkOrErrFile(FTPUtils.ftpHost,FTPUtils.ftpPort, FTPUtils.ftpUserName, FTPUtils.ftpPassword,  FTPUtils.ftpPath, tempCaxaPathName, workDir);
					// ʧܣһftpԱָļtxtshxλãȡʹõȱʡ壩Ȼ󵯳Դλ\ĵ
					if (downResult == false) {
						caxaInfo = caxaInfo + ";" + "ӳʧ";//:id" + item_id + "  汾" + item_rev_id;
						return;
					}
					// ɹ ɾftpϵͬtxt ȴpdf
					if (debug)
						System.out.println("ɾ " + tempCaxaPathName.replace(".exb", ".txt"));
					boolean getPdf = deleteTxt(FTPUtils.ftpHost,FTPUtils.ftpPort, FTPUtils.ftpUserName, FTPUtils.ftpPassword,  FTPUtils.ftpPath,tempCaxaPathName, workDir);
					if (!getPdf) {
						caxaInfo = caxaInfo + ";" + "txtɾʧ";//:id" + item_id + "  汾" + item_rev_id;
						return;
					}
//
					// 滻caxa
					if (debug)
						System.out.println("caxa");
					count = 0;
					boolean downCaxa = downFile(FTPUtils.ftpHost,FTPUtils.ftpPort, FTPUtils.ftpUserName, FTPUtils.ftpPassword,  FTPUtils.ftpPath, tempCaxaPathName, workDir);
					if (downCaxa == false) {
						if (debug)
							System.out.println("caxaʧ");
						caxaInfo = caxaInfo + ";" + "caxaʧ";//:id" + item_id + "  汾" + item_rev_id;
						return;
					}

					if (new File(workDir + "\\" + fileOgiginName).exists()) {
						new File(workDir + "\\" + fileOgiginName).delete();
					}
					// пַܰ
					boolean caxaFile = new File(workDir + "\\" + tempCaxaPathName)
							.renameTo(new File(workDir + "\\" + fileOgiginName));
					if (caxaFile == false) {
						caxaInfo = caxaInfo + ";" + "ʧ";//:id" + item_id + "  汾" + item_rev_id;
						return;
					}
					if (debug)
						System.out.println("滻");

					TcUtils.setByPass(true);
					//2023-11-15 liujb Ӳ start
					File tcFileToFile = TCFileToFile(dataset);
					File exbFile = new File("D:\\TEMP\\fcc_tmp"+ "\\" + fileOgiginName);
					if (exbFile.exists()) {
						exbFile.delete();
					}
					boolean caxaFile2 = tcFileToFile.renameTo(exbFile);
					String fileName = exbFile.getPath()+"@"+rev.getUid()+"#"+dataset.getUid()+"#"+releaseStatus;
					File lockFile = new File(fileName);
					
					boolean createNewFile = lockFile.createNewFile();
					
					updateDataSet(dataset, workDir + "\\" + fileOgiginName,"U2_EXB");
					exbFile.delete();
					lockFile.delete();
					TcUtils.setByPass(false);

					if (debug)
						System.out.println("滻caxaɹ·id");//" + item_id + "  汾" + item_rev_id);

//					// 滻pdf
//					if (debug)
//						System.out.println("ʼpdf");
//					boolean sucess = downFile(FTPUtils.ftpHost,FTPUtils.ftpPort, FTPUtils.ftpUserName, FTPUtils.ftpPassword,  FTPUtils.ftpPath,
//							tempCaxaPathName.replace(".exb", ".pdf"), workDir);
//					if (sucess == false) {
//						// TODO ־
//						System.out.println();
//
//					}					
//						boolean action = false;
//						String addPdfPath = "";
//						try {
//							
//							// Ҫǩ
//							String item_id = rev.get_item_id();
//							String item_rev_id = rev.get_item_revision_id();
//							if("HX".equals(FTPUtils.CompanyName)) {
//								String designType = rev.getTypeObject().getName();
//								String[] imgPath = new String[1];
//								
//								String path = caxaPropertyHandler.class.getProtectionDomain().getCodeSource().getLocation().getPath();
//								path = path.replace("%20", " ");
//								String exePath = new File(path).getParent() + "//";
//								String qianzhang = rev.getPropertyDisplayableValue("hx3_qianzhang").trim();
//								if(qianzhang.equals("ܿ") || qianzhang.equals("B") || qianzhang.isEmpty()) {
//									
//									exePath = exePath + "skz.png";
//								}
//								else {
//									exePath = exePath + "syz.png";
//								
//							}
//			
//							imgPath[0] = exePath;
//							item_id = newString(item_id);
//							
//								
//							action = addPdfMark(workDir + File.separator + tempCaxaPathName.replace(".exb", ".pdf"),
//										workDir + File.separator + item_id + item_rev_id + ".pdf", imgPath, designType);
//							}
//							// pdfߴ粻ģ壬ܿʧܣʱͰԭpdf滻ȥ
//							if (action == false) {
//								
//								addPdfPath = workDir + File.separator+tempCaxaPathName.replace(".exb", ".pdf");//workDir + File.separator + fileName.replace(".exb", ".pdf");
//							
//							} else {
//	
//								addPdfPath = workDir + File.separator + item_id + item_rev_id + ".pdf";
//							}
//						} catch (Exception e) {
//							// 3ʾͼƬ쳣
//							String HXC_STATUS = "3";
//							e.printStackTrace();
//							addPdfPath = workDir + File.separator+tempCaxaPathName.replace(".exb", ".pdf");
//						}
//					
//					// ñʾ
					System.out.println("״̬תͼʶ");
					replaceOrcreate(dataset, rev);
//					System.out.println("addPdfPath:"+addPdfPath);

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private static boolean deleteTxt(String url, // FTPhostname
			int port, // FTP˿
			String username, // FTP¼˺
			String password, // FTP¼
			String remotePath, // FTPϵ·
			String fileName, // Ҫصļ
			String localPath// غ󱣴浽ص·

	) {

		boolean success = false;
		FTPClient ftp = new FTPClient();
		try {
			int reply;
			ftp.connect(url, port);
			// Ĭ϶˿ڣʹftp.connect(url)ķʽֱFTP
			ftp.login(username, password);// ¼
//            ftp.login("anonymous", null);// ½FTP
			reply = ftp.getReplyCode();
			if (!FTPReply.isPositiveCompletion(reply)) {
				ftp.disconnect();
				return success;
			}
			ftp.enterLocalPassiveMode();// 䣬ЩԴ˷ǽͻftp.listFiles()￨ס
//            if(debug)System.out.println("aaa");
			boolean ftpchange = ftp.changeWorkingDirectory(remotePath);// תƵFTPĿ¼
			fileName = fileName.replace(".exb", ".txt");
			ftp.setControlEncoding("GBK"); //FTP ֧
			fileName = convGBKtoISO(fileName);//FTP ֧
			int flag = ftp.dele(fileName);
			success = true;

		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (ftp.isConnected()) {
				try {
					ftp.disconnect();
				} catch (IOException ioe) {
				}
			}
		}
		return success;

	}
static int count = 0;// 
//
	public static FTPFile[] waitPdf(FTPClient ftp, String fileName, String errorName, String okName) {
		FTPFile[] fs = null;
		try {

			fs = ftp.listFiles();
		} catch (IOException e1) {
			e1.printStackTrace();
		}

		for (FTPFile ff : fs) {
			//2023.04.06ҵ.okΪɹ.errorΪʧܲ
			//FTP֧
			String ffName = convISOtoGBK(ff.getName());
			if (ffName.equals(okName)) {
				System.out.println("find the pdf...");
				return fs;
			} else if (ffName.equals(errorName)) {
				System.out.println("ת쳣");
				return null;
			}
		}
		System.out.println("waitPdf---count:" + count);
		System.out.println("waitPdf----waitPdf:" + waitPdf);
		try {
			Thread.sleep(1000);
			count++;
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		// ʱ˳
		if (count > waitPdf) {
			return null;
		}
		fs = waitPdf(ftp, fileName, errorName, okName);
		return fs;
	}
//
	public static boolean downOkOrErrFile(String url, // FTPhostname
			int port, // FTP˿
			String username, // FTP¼˺
			String password, // FTP¼
			String remotePath, // FTPϵ·
			String fileName, // Ҫصļ
			String localPath// غ󱣴浽ص·

	) {
		boolean success = false;
		FTPClient ftp = new FTPClient();
		try {
			int reply;
			ftp.connect(url, port);
			// Ĭ϶˿ڣʹftp.connect(url)ķʽֱFTP
			ftp.login(username, password);// ¼
//            ftp.login("anonymous", null);// ½FTP
			reply = ftp.getReplyCode();
			if (!FTPReply.isPositiveCompletion(reply)) {
				ftp.disconnect();
				return success;
			}
			ftp.enterLocalPassiveMode();// 䣬ЩԴ˷ǽͻftp.listFiles()￨ס
//            if(debug)System.out.println("aaa");
			boolean ftpchange = ftp.changeWorkingDirectory(remotePath);// תƵFTPĿ¼
//            if(debug)System.out.println(ftpchange);
//            FTPFile[] fs = ftp.listFiles(); 
			String errorNamePrefix = "";
			if (fileName.toLowerCase().endsWith(".exb")) {
				errorNamePrefix = fileName;
			}

			FTPFile[] fs = waitOkOrErrFile(ftp, fileName, errorNamePrefix);
			if (fs != null) {
				success = true;
			} else {
				success = false;
			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (ftp.isConnected()) {
				try {
					ftp.disconnect();
				} catch (IOException ioe) {
				}
			}
		}
		return success;
	}

//
	public static FTPFile[] waitOkOrErrFile(FTPClient ftp, String fileName, String errorNamePrefix) {
		FTPFile[] fs = null;
		try {

			fs = ftp.listFiles();
		} catch (IOException e1) {
			e1.printStackTrace();
		}

		for (FTPFile ff : fs) {
			// 2023.04.06ҵ.okΪɹ.errorΪʧܲ
			// FTP֧
			String ffName = convISOtoGBK(ff.getName());
			System.out.println("ffName:"+ffName);
			System.out.println("errorNamePrefix:"+errorNamePrefix);
			if (ffName.equals(errorNamePrefix + ".ok")) {
				System.out.println("ӳɹ...");
				return fs;
			} else if (ffName.equals(errorNamePrefix + ".err")) {
				System.out.println("ӳ쳣");
				return null;
			}
		}
		if (debug)
			System.out.println("waitOkOrErrFile---" + errorNamePrefix);
		try {
			Thread.sleep(1000);
			waitOkOrErrFileCount++;
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		// ʱ˳
		if (waitOkOrErrFileCount > waitPdf) {
			return null;
		}
		fs = waitOkOrErrFile(ftp, fileName, errorNamePrefix);
		return fs;
	}
//
	static	int waitOkOrErrFileCount = 0;
//
	/**
	 * ȡ
	 * 
	 * @param comp
	 * @return
	 */
	public static String hx_GetProp(ModelObject comp, String refInfo) {
		if (comp == null) {
			return null;
		}
		if (refInfo == null) {
			return null;
		}
		try {
			dmService.getProperties(new ModelObject[] {comp}, new String[] {refInfo});
			return comp.getPropertyDisplayableValue(refInfo);
//			return comp.getProperty(refInfo);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return "";
	}
	
    public static String toUpperCase(String input) {
        if (input == null) {
            return null;
        }

        int length = input.length();
        StringBuilder result = new StringBuilder(length);

        for (int i = 0; i < length; i++) {
            char c = input.charAt(i);
            if (c >= 'a' && c <= 'z') {
                // СдĸתΪдĸ
                c = (char) (c - 32);
            }
            result.append(c);
        }

        return result.toString();
    }
    
    public static String getPrefValue(String prefName) {
        SessionService sessionService = SessionService.getService(AppXSession.getConnection());
        Session.ScopedPreferenceNames preferenceNames = new Session.ScopedPreferenceNames();
        preferenceNames.names = new String[]{prefName};
        preferenceNames.scope = "site";
        com.teamcenter.services.strong.core._2010_04.Session.MultiPreferenceResponse2 resp = sessionService.getPreferences2(new Session.ScopedPreferenceNames[]{preferenceNames});
        com.teamcenter.services.strong.core._2010_04.Session.ReturnedPreferences2[] prefs = resp.preferences;
        if (prefs == null || prefs.length == 0) {
            return ("ѡ + prefName + ");
        }
        String[] values = prefs[0].values;
        if (values == null || values.length == 0) {
            return "ѡ + prefName + δ";
        }
        return values[0];
    }
//
	/**
	 * ЭCAXAݼǰ
	 * 
	 * @param caxaDataset
	 * @param rev 
	 * @throws TCException
	 */
	public static boolean hx_SetCAXAFile(Dataset caxaDataset, String xmlName,String datasetName, ItemRevision rev)
			throws Exception {
		try {
			String forceOpenDirect = getPrefValue("PX_SignatureImagePath");
			
			StringBuffer infoSB = new StringBuffer();
			String path = caxaPropertyHandler.class.getProtectionDomain().getCodeSource().getLocation().getPath();
			path = path.replace("%20", " ");
			String exePath = new File(path).getParent() + "//";

			SAXReader reader = new SAXReader();
			Document doc = reader.read(new File(exePath + "sign.xml"));
			Element root = doc.getRootElement();
			Element title = root.element("SignInfo").element("Title");
			Element files = root.element("SignInfo").element("Files").element("File");
//			files.attribute("Path").setValue("D:\\CAXAPROPERTY\\" + xmlName + ".exb");
			files.attribute("Path").setValue(FTPUtils.ftpPath + "\\" + xmlName + ".exb");
			String blockName = files.attributeValue("BlockName");
			Map<String, String> valueMap = getECNValueMap(rev);
			
			datasetName = datasetName.substring(0, datasetName.indexOf('.'));
			File file = new File(System.getenv("TEMP") + "\\" + xmlName + ".xml");

			dmService.getProperties(new ModelObject[] {rev}, new String[] {"IMAN_master_form_rev"});
				ModelObject revForm = rev.get_IMAN_master_form_rev()[0];

			Item item = rev.get_items_tag();
			
			List<String> refValues = new ArrayList<String>();//tcp.getStringArray(TCPreferenceService.TC_preference_site, "HxCaxaMapping");
			
			//ȡļеǩϢ
			// ·жȡļ
	        InputStream resourceAsStream = test.class.getResourceAsStream("signoff.properties");

	        // ȡļ
	        Properties properties = new Properties();
	        try {
	            properties.load(resourceAsStream);
	        } catch (Exception e) {
	            System.out.println("öȡʧ");
	            e.printStackTrace();
	            return false;
	        }

	        // ȡ
	        for (String key : properties.stringPropertyNames()) {
	            String value = properties.getProperty(key);
	            
	            // еתַUnicode
	            String decodedKey = URLDecoder.decode(key.replace("\\:", ":"));
	            String decodedValue = URLDecoder.decode(value);
	            
	            System.out.println("ֵ: " + decodedKey + "=" + decodedValue);
	            String frece = decodedKey + "=" + decodedValue;
	            refValues.add(frece);
	        }
			
			if (refValues == null || refValues.size() == 0) {

				return false;
			}
			String propName;
			int index;

			
			List<String> itemPropList = new ArrayList<String>();
			List<String> itemRevPropList = new ArrayList<String>();
			List<String> itemRevMasterPropList = new ArrayList<String>();
			for (String refValue : refValues) {
				String[] valueS = refValue.split("=");

				String value = null;
				if (valueS == null || valueS.length != 2) {
					continue;
				}
				String[] propNameS = valueS[1].split("\\.");
				if (propNameS == null || propNameS.length != 2) {
					continue;
				}
				index = valueS[0].indexOf(':');
				propName = valueS[0].substring(index + 1).trim();
				String propNameS0Upper = toUpperCase(propNameS[0]);

				if ("ITEM".equals(propNameS0Upper)) {
				    if (!itemPropList.contains(propNameS[1])) {
				        itemPropList.add(propNameS[1]);
				    }
				} else if ("REV".equals(propNameS0Upper)) {
				    if (!itemRevPropList.contains(propNameS[1])) {
				        itemRevPropList.add(propNameS[1]);
				    }
				} else if ("REVMASTER".equals(propNameS0Upper)) {
				    if (!itemRevMasterPropList.contains(propNameS[1])) {
				        itemRevMasterPropList.add(propNameS[1]);
				    }
				} else if ("ITEMMASTER".equals(propNameS0Upper)) {
				} else {
				}
				
			}
			if(itemPropList.size()!=0) {
				String[] itemProps = itemPropList.toArray(new String[itemPropList.size()]);
				dmService.getProperties(new ModelObject[] {item}, itemProps);
			}
			if(itemRevPropList.size()!=0) {
				String[] itemRevProps = itemRevPropList.toArray(new String[itemRevPropList.size()]);
				dmService.getProperties(new ModelObject[] {rev}, itemRevProps);
			}
			if(itemRevMasterPropList.size()!=0) {
				String[] itemRevMasterProps = itemRevMasterPropList.toArray(new String[itemRevMasterPropList.size()]);
				dmService.getProperties(new ModelObject[] {revForm}, itemRevMasterProps);
			}
			dmService.refreshObjects(new ModelObject[] {item,rev,revForm});
			for (String refValue : refValues) {
				String[] valueS = refValue.split("=");

				String value = null;
				if (valueS == null || valueS.length != 2) {
					continue;
				}
				String[] propNameS = valueS[1].split("\\.");
				if (propNameS == null || propNameS.length != 2) {
					continue;
				}
				index = valueS[0].indexOf(':');
				propName = valueS[0].substring(index + 1).trim();
				if(propName.equals("Ա")) {
					System.out.println();
				}
				if(valueMap.containsKey(propName)) {
					continue;
				}
				String propNameS0Upper = toUpperCase(propNameS[0]);

				if ("ITEM".equals(propNameS0Upper)) {
				    value = hx_GetProp(item, propNameS[1]);
				} else if ("REV".equals(propNameS0Upper)) {
				    boolean flag = false;
				    String[] propertyNames = rev.getPropertyNames();
				    for (String prop : propertyNames) {
				        if (prop.equals(propNameS[1]) && !valueMap.containsKey(prop)) {
				            flag = true;
				            break;
				        }
				    }
				    if (flag) {
				        value = hx_GetProp(rev, propNameS[1]);
				    }
				} else if ("REVMASTER".equals(propNameS0Upper)) {
				    boolean flag2 = false;
				    String[] propertyNames2 = revForm.getPropertyNames();
				    for (String prop : propertyNames2) {
				        if (prop.equals(propNameS[1]) && !valueMap.containsKey(prop)) {
				            flag2 = true;
				            break;
				        }
				    }
				    if (flag2) {
				        value = hx_GetProp(revForm, propNameS[1]);
				    }
				} else if ("ITEMMASTER".equals(propNameS0Upper)) {
				} else {
				}

				if (value == null  || value.length() == 0)
					continue;
				valueMap.put(propName, value);
			}

			Element e;
			Iterator it = title.elementIterator();
			while (it.hasNext()) {
				e = (Element) it.next();
				
				String val = valueMap.get(e.attribute("Name").getValue());
				if (val != null) {
				    System.out.println("·" + forceOpenDirect + val + ".jpg");

				    String[] extensions = {".jpg", ".jpeg", ".png", ".PNG"};
				    File sourceFile = null;

				    // ҴڵԴļ
				    for (String ext : extensions) {
				        File f = new File(forceOpenDirect + val + ext);
				        if (f.exists()) {
				            sourceFile = f;
				            break;
				        }
				    }

				    if (sourceFile != null) {
				        try {
				            // ʱĿ¼ѡ
				            File tempDir = new File(System.getProperty("java.io.tmpdir"), "caxa_images");
				            if (!tempDir.exists()) {
				                tempDir.mkdirs();
				            }

				            // ȡԭʼչ
				            String originalExt = sourceFile.getName()
				                    .substring(sourceFile.getName().lastIndexOf("."));

				            // һΨһʱļ
				            File tempFile = File.createTempFile("img_", originalExt, tempDir);

				            // ļ
				            InputStream is = null; // ڴԴļжȡ
				            OutputStream os = null; // ڽдĿļ
				            try {
				                // ָԴļ
				                is = new FileInputStream(sourceFile);
				                // ָĿļ
				                os = new FileOutputStream(tempFile);
				                // һֽڻʱ洢ȡݣСΪ 1024 ֽ
				                byte[] buffer = new byte[1024];
				                int length; // ڴ洢ÿζȡֽ
				                // ѭȡԴļݣֱļread()  -1
				                while ((length = is.read(buffer)) > 0) {
				                    // ȡдĿļӻʼλÿʼд룬д볤Ϊȡֽ
				                    os.write(buffer, 0, length);
				                }
				            } finally {
				                // رͷԴ
				                if (is != null) {
				                    is.close();
				                }
				                // رͷԴ
				                if (os != null) {
				                    os.close();
				                }
				            }
//				            Files.copy(sourceFile.toPath(), tempFile.toPath());

				            //  XML Ϊ·
				            e.attribute("Type").setValue("Image");
				            e.attribute("Value").setValue("W:\\"+tempFile.getName());

				        } catch (IOException ex) {
				            ex.printStackTrace();
				            // ʱΪַ
				            e.attribute("Type").setValue("String");
				            e.attribute("Value").setValue(val);
				        }
				    } else {
				        // ļڣΪַ
				        e.attribute("Type").setValue("String");
				        e.attribute("Value").setValue(val);
				    }
				}
//				if (val != null) {
//					System.out.println("·"+forceOpenDirect+val+".jpg");
//					
//					
//					if(new File(forceOpenDirect+val+".jpg").exists()) {
//						e.attribute("Type").setValue("Image");
//						e.attribute("Value").setValue(forceOpenDirect+val+".jpg");
//					}else if(new File(forceOpenDirect+val+".jpeg").exists()) {
//						e.attribute("Type").setValue("Image");
//						e.attribute("Value").setValue(forceOpenDirect+val+".jpeg");
//					}else if(new File(forceOpenDirect+val+".png").exists()) {
//						e.attribute("Type").setValue("Image");
//						e.attribute("Value").setValue(forceOpenDirect+val+".png");
//					}else if(new File(forceOpenDirect+val+".PNG").exists()) {
//						e.attribute("Type").setValue("Image");
//						e.attribute("Value").setValue(forceOpenDirect+val+".PNG");
//					}else {
//						e.attribute("Type").setValue("String");
//						e.attribute("Value").setValue(val);
//					}
//				}
			}
			PrintWriter pw = new PrintWriter(file, "UTF-8");
			doc.write(pw);
			pw.close();
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		return true;

	}

	public static void second(File file) {
		if (!file.exists()) {
			if (debug)
				System.out.println("second");
			try {
				Thread.sleep(200);
				second(file);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		} else {
			if (debug)
				System.out.println("cunzai");
			try {
				Thread.sleep(200);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}
//
	/**
	 * ɾļ
	 *
	 * @param fileName Ҫɾļļ
	 * @return ļɾɹtrue򷵻false
	 */
	public static boolean deleteFile(String fileName) {
		File file = new File(fileName);
		// ļ·Ӧļڣһļֱɾ
		if (file.exists() && file.isFile()) {
			if (file.delete()) {
//				if(debug)System.out.println("ɾļ" + fileName + "ɹ");
				return true;
			} else {
//				if(debug)System.out.println("ɾļ" + fileName + "ʧܣ");
				return false;
			}
		} else {
//			if(debug)System.out.println("ɾļʧܣ" + fileName + "ڣ");
			return false;
		}
	}
//	
//
	/**
	 * ɾĿ¼Ŀ¼µļ
	 *
	 * @param dir ҪɾĿ¼ļ·
	 * @return Ŀ¼ɾɹtrue򷵻false
	 */
	public static boolean deleteDirectory(String dir) {
		// dirļָβԶļָ
		if (!dir.endsWith(File.separator))
			dir = dir + File.separator;
		File dirFile = new File(dir);
		// dirӦļڣ߲һĿ¼˳
		if ((!dirFile.exists()) || (!dirFile.isDirectory())) {
//			if(debug)System.out.println("ɾĿ¼ʧܣ" + dir + "ڣ");
			return false;
		}
		boolean flag = true;
		// ɾļеļĿ¼
		File[] files = dirFile.listFiles();
		for (int i = 0; i < files.length; i++) {
			// ɾļ
			if (files[i].isFile()) {
				flag = deleteFile(files[i].getAbsolutePath());
				if (!flag)
					break;
			}
			// ɾĿ¼
			else if (files[i].isDirectory()) {
				flag = deleteDirectory(files[i].getAbsolutePath());
				if (!flag)
					break;
			}
		}
		if (!flag) {
//			if(debug)System.out.println("ɾĿ¼ʧܣ");
			return false;
		}
		return true;
	}
//
	// ȡеȴpdfתʱʱ
	private static void loadWaitPdf() {
		Properties properties = new Properties();
		InputStream is = null;
//		is = this.getClass().getResourceAsStream("PDFInfo.properties");
		is =  caxaPropertyHandler.class.getResourceAsStream("PDFInfo.properties");
		try {
			properties.load(is);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		waitPdf = Integer.valueOf(properties.getProperty("WAITPDF"));
		System.out.println();
	}
//
//	private void dealWithFolder(TCComponent tcComponent) throws TCException {
//		if (tcComponent instanceof TCComponentFolder) {
//			TCComponentFolder folder = (TCComponentFolder) tcComponent;
//			TCComponent[] contents = null;
//			try {
//				contents = folder.getRelatedComponents("contents");
//			} catch (TCException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			}
//			for (int j = 0; j < contents.length; j++) {
//				TCComponent content = contents[j];
//				if (content instanceof TCComponentFolder) {
//					dealWithFolder(content);
//				} else if (content instanceof TCComponentItem) {
//					TCComponentItemRevision rev = ((TCComponentItem) content).getLatestItemRevision();
//					caxaToPdf(rev, logger);
//				} else if (content instanceof TCComponentItemRevision) {
//					caxaToPdf((TCComponentItemRevision) content, logger);
//				}
//			}
//		}
//
//	}
//
	/**
	 * ȡFTPClient
	 *
	 * @param ftpHost     FTP
	 * @param ftpPassword FTP ¼
	 * @param ftpUserName FTP¼û
	 * @param ftpPort     FTP˿ ĬΪ21
	 * @return
	 */
	public static FTPClient getFTPClient(String ftpHost, String ftpUserName, String ftpPassword, int ftpPort) {
		FTPClient ftpClient = new FTPClient();
		try {
			ftpClient = new FTPClient();
			ftpClient.connect(ftpHost, ftpPort);// FTP
			ftpClient.login(ftpUserName, ftpPassword);// ½FTP
//            ftpClient.login("anonymous", null);// ½FTP
			if (!FTPReply.isPositiveCompletion(ftpClient.getReplyCode())) {
				if (debug)
					System.out.println("δӵFTPû");
				ftpClient.disconnect();
			} else {
//                if(debug)System.out.println("FTPӳɹ");
			}
		} catch (SocketException e) {
			e.printStackTrace();
			if (debug)
				System.out.println("FTPIPַܴȷá");
		} catch (IOException e) {
			e.printStackTrace();
			if (debug)
				System.out.println("FTPĶ˿ڴ,ȷá");
		}
		return ftpClient;
	}
//
	/**
	 * Description: FTPϴļ
	 * 
	 * @param ftpHost     FTPhostname
	 * @param ftpUserName ˺
	 * @param ftpPassword 
	 * @param ftpPort     ˿
	 * @param ftpPath     FTPļ· ʽ ftptest/aa
	 * @param fileName    ftpļ
	 * @param in          ļ
	 * @return ɹtrue򷵻false
	 */
	public static boolean uploadFile(String ftpHost, String ftpUserName, String ftpPassword, int ftpPort, String ftpPath,
			String fileName, FileInputStream in) {
		boolean success = false;
		FTPClient ftpClient = null;
		try {
			int reply;
			ftpClient = getFTPClient(ftpHost, ftpUserName, ftpPassword, ftpPort);
			reply = ftpClient.getReplyCode();
			if (!FTPReply.isPositiveCompletion(reply)) {
				ftpClient.disconnect();
				return success;
			}
			ftpClient.setFileType(FTPClient.BINARY_FILE_TYPE);
			ftpClient.enterLocalPassiveMode();
			ftpClient.changeWorkingDirectory(ftpPath);
			
			ftpClient.setControlEncoding("GBK"); // FTP֧
			fileName = convGBKtoISO(fileName);// FTP֧
			////fileName = convISOtoGBK(fileName);// FTP֧
			
			boolean ff = ftpClient.storeFile(fileName, in);	
			String str = ftpClient.getReplyString();
			in.close();
			ftpClient.logout();
			success = true;
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (ftpClient.isConnected()) {
				try {
					ftpClient.disconnect();
				} catch (IOException ioe) {
				}
			}
		}
//        if(debug)System.out.println("ϴ");
		return success;
	}
//
//	public String GetNowDate() {
//		String temp_str = "";
//		Date dt = new Date();
//		// aaʾ硱硱 HHʾ24Сʱ hhʾ12Сʱ "yyyy-MM-ddHH:mm:ss aa"
//		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd-HH-mm");
//		temp_str = sdf.format(dt);
//		return temp_str;
//	}
//
//	/*
//	 * ʵļĿ
//	 * 
//	 * @param srcPathStr ԴļĵַϢ
//	 * 
//	 * @param desPathStr ĿļĵַϢ
//	 */
//	private String copyFile(String srcPathStr, String desPathStr, String newName) {
//		// 1.ȡԴļ
//		String newFileName = newName + srcPathStr.substring(srcPathStr.lastIndexOf(".")); // Ŀļַ
////        if(debug)System.out.println(newFileName);
////        if(debug)System.out.println(File.separator);
//		desPathStr = desPathStr + File.separator + newFileName; // Դļַ
////        if(debug)System.out.println(desPathStr);
//
//		try {
//			// 2.
//			FileInputStream fis = new FileInputStream(srcPathStr);
//			FileOutputStream fos = new FileOutputStream(desPathStr);
//
//			// ˹
//			byte datas[] = new byte[1024 * 8];
//			// 
//			int len = 0;
//			// ѭȡ
//			while ((len = fis.read(datas)) != -1) {
//				fos.write(datas, 0, len);
//			}
//			// 3.ͷԴ
//			fis.close();
//			fis.close();
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//		return desPathStr;
//	}
//
	public static boolean downFile(String url, // FTPhostname
			int port, // FTP˿
			String username, // FTP¼˺
			String password, // FTP¼
			String remotePath, // FTPϵ·
			String fileName, // Ҫصļ
			String localPath// غ󱣴浽ص·

	) {
		if (debug)
			System.out.println("");
		boolean success = false;
		FTPClient ftp = new FTPClient();
		try {
			int reply;
			ftp.connect(url, port);
			// Ĭ϶˿ڣʹftp.connect(url)ķʽֱFTP
			ftp.login(username, password);// ¼
//            ftp.login("anonymous", null);// ½FTP
			reply = ftp.getReplyCode();
			if (!FTPReply.isPositiveCompletion(reply)) {
				if (debug)
					System.out.println("Ͽ");
				ftp.disconnect();
				return success;
			}
//            if(debug)System.out.println("aaa");
			ftp.changeWorkingDirectory(remotePath);// תƵFTPĿ¼
//            FTPFile[] fs = ftp.listFiles();  
			int x = 0;
			if (debug)
				System.out.println("ȴpdf");
			String errorName = fileName + ".err";
			String okName = fileName + ".ok";
			FTPFile[] fs = waitPdf(ftp, fileName, errorName, okName);
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			if (fs == null) {
				return false;
			}
			ftp.setControlEncoding("GBK");
			for (FTPFile ff : fs) {
				// FTP֧
				String ffName = convISOtoGBK(ff.getName());
				if (ffName.equals(fileName)) {
					if (debug)
						System.out.println("ļ----------" + fileName);
//                 if(debug)System.out.println("dd");
					File localFile = new File(localPath + "/" + ffName);
					OutputStream is = new FileOutputStream(localFile);
					ftp.retrieveFile(ff.getName(), is);
//                    if(debug)System.out.println("ccc" +ff.getName()+fileName);
					is.close();
					success = true;
					break;//2023-04-12ѭ
				}
			}
			ftp.logout();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (ftp.isConnected()) {
				try {
					ftp.disconnect();
				} catch (IOException ioe) {
				}
			}
		}
		return success;
	}
//
	/**
	 * ȡPDFĳߴͼƥ䲢ҪͼƬλ
	 * 
	 * @param rectangle
	 * @return
	 */
	public static Float[] getSize(Rectangle rectangle) {
		Float[] sizef = new Float[2];
		float toleft = rectangle.getLeft();
		float tobottom = rectangle.getBottom();
		float toright = rectangle.getRight();
		float totop = rectangle.getTop();

		JFomPdfBean bean = new JFomPdfBean();
		bean.setH(toright - toleft);// PDFĿ
		bean.setW(totop - tobottom);// PDFĸ
		sizef[0] = bean.getH();
		sizef[1] = bean.getW();
//		if(debug)System.out.println("bean.getH------------>" + bean.getH());
//		if(debug)System.out.println("bean.getW------------>" + bean.getW());

		return sizef;
	}

	public static boolean addPdfMark(String InPdfFile, String temp, String[] markImagePath, String designType)
			throws Exception {
		File pdffile = new File(temp);
		if (pdffile.exists()) {
			pdffile.delete();
		}
		// 
		Properties properties = new Properties();
		InputStream is = null;
		is = caxaPropertyHandler.class.getResourceAsStream("PDFInfo.properties");
		properties.load(is);
		System.out.println(2);
		// PDF ļ
		PdfReader reader = new PdfReader(InPdfFile, "PDF".getBytes());
		// PDF ļ
		PdfStamper stamp = new PdfStamper(reader, new FileOutputStream(temp));
		// ˮӡͼƬ
		Image[] img = null;
		for (int j = 0; j < markImagePath.length; j++) {
//			img.scaleAbsolute(35, 20);// ͼƬ
//			float imgW = img.getScaledWidth();// ȡͼƬĿ
//			float imgH = img.getScaledHeight();// ȡͼƬĸ߶
			// ȡPDFҳ
			int pageSize = reader.getNumberOfPages();// ȡļҳ
			for (int i = 1; i <= pageSize; i++) {
				Rectangle rectangle = reader.getPageSize(i);
				Float[] fposition = getSize(rectangle);
//				if(debug)System.out.println("fposition[0]======="+fposition[0]);
//				if(debug)System.out.println("fposition[1]======="+fposition[1]);
				boolean isSizeOk = false;
				// ˮӡĲλA0
				if ((fposition[0] > 3300 && fposition[1] > 2300)) {
					isSizeOk = true;
					// ͨpdfڵİ汾ж
//					if(debug)System.out.println("ˮӡĲλA0");
					String[] sizeType = selectType("A0", designType);
					if (sizeType == null || sizeType.length == 0) {
						return false;
					}
					img = setPic(img, sizeType, properties, markImagePath[j]);
				}
				// TODO ˮӡĲλA1
				if ((fposition[0] > 2300 && fposition[1] > 1600) && isSizeOk == false) {
					isSizeOk = true;
//					if(debug)System.out.println("ˮӡĲλA1");
					String[] sizeType = selectType("A1", designType);
					if (sizeType == null || sizeType.length == 0) {
						return false;
					}
					
					img = setPic(img, sizeType, properties, markImagePath[j]);
					
				}

				// TODO ˮӡĲλA2
				if ((fposition[1] > 1100 && fposition[0] > 1600) && isSizeOk == false) {
					isSizeOk = true;
//					if(debug)System.out.println("ˮӡĲλA2");
					String[] sizeType = selectType("A2", designType);
					if (sizeType == null || sizeType.length == 0) {
						return false;
					}
					img = setPic(img, sizeType, properties, markImagePath[j]);
				}
				// TODO ˮӡĲλA2
				if ((fposition[0] > 1100 && fposition[1] > 1600) && isSizeOk == false) {
					isSizeOk = true;
//					if(debug)System.out.println("ˮӡĲλA2_GY");
					String[] sizeType = selectType("A2", designType);
					if (sizeType == null || sizeType.length == 0) {
						return false;
					}
					img = setPic(img, sizeType, properties, markImagePath[j]);
				}
				// TODO ˮӡĲλA3
				if ((fposition[0] > 1100 && fposition[1] > 800) && isSizeOk == false) {
					isSizeOk = true;
//					if(debug)System.out.println("ˮӡĲλA3");
					String[] sizeType = selectType("A3", designType);
					if (sizeType == null || sizeType.length == 0) {
						return false;
					}
					img = setPic(img, sizeType, properties, markImagePath[j]);
				}
				// TODO ˮӡĲλA3H 
				if ((fposition[1] > 1100 && fposition[0] > 800) && isSizeOk == false) {
					isSizeOk = true;
//					if(debug)System.out.println("ˮӡĲλA3");
					String[] sizeType = selectType("A3H", designType);
					if (sizeType == null || sizeType.length == 0) {
						return false;
					}
					img = setPic(img, sizeType, properties, markImagePath[j]);
				}
				// TODO ˮӡĲλA4 
				if ((fposition[1] > 800 && fposition[0] > 500) && isSizeOk == false) {
					isSizeOk = true;
//					if(debug)System.out.println("ˮӡĲλA4");
					String[] sizeType = selectType("A4", designType);
					if (sizeType == null || sizeType.length == 0) {
						return false;
					}
					img = setPic(img, sizeType, properties, markImagePath[j]);
				}
				// ˮӡĲλA4 
				if ((fposition[0] > 800 && fposition[1] > 500) && isSizeOk == false) {
					isSizeOk = true;
//					if(debug)System.out.println("ˮӡĲλA4");
					String[] sizeType = selectType("A4H", designType);
					if (sizeType == null || sizeType.length == 0) {
						return false;
					}
					
					img = setPic(img, sizeType, properties, markImagePath[j]);
					System.out.println();
				}
//				
//				if (sizeType != null) {
//
//					img = setPic(img, sizeType, properties, markImagePath[j]);
//				}
				if (img == null ) {
					img = new Image[1];
					img[0] = Image.getInstance(markImagePath[j]);// ȡͼƬʵ
					img[0].setAbsolutePosition(Float.valueOf(10), Float.valueOf(10));
					/*
					 * isModel=false; continue;
					 */
				}
				if (img == null) {
					return false;
				}

				// PDFļвˮӡ
				PdfContentByte under = stamp.getOverContent(i);// stamp.getUnderContent(i);
				PdfGState gs = new PdfGState();
				gs.setFillOpacity(1.0f);// ͸Ϊ0.2
				under.setGState(gs);
				for (int k = 0; k < img.length; k++) {
					under.addImage(img[k]);

				}
			}
		}
		stamp.close();// ر
		reader.close();// ر
		File tempfile = new File(InPdfFile);
		if (tempfile.exists()) {
			// ɾԭļ
			tempfile.delete();
		}
		return true;
	}


//	public static String[] selectType(String Ax, String designType) {
//		String[] type = null;
//		switch (designType) {
//
//		case "HX3_GYTRevision":// ͼ
//			if (Ax.equals("A3")) {
//				type = new String[1];
//				type[0] = Ax + "_GY";
//			} else if (Ax.equals("A2")) {
//				type = new String[2];
//				type[0] = Ax + "_GY1";
//				type[1] = Ax + "_GY2";
//			}
//			break;
//		case "HX3_TYGY1Revision":// ͨù
//			if (Ax.equals("A3")) {
//				type = new String[1];
//				type[0] = Ax + "_TYGY";
//			} else if (Ax.equals("A2")) {
//				type = new String[2];
//				type[0] = Ax + "_TYGY1";
//				type[1] = Ax + "_TYGY2";
//			}
//			break;
//		case "HX3_WXTRevision":// ƷͼЭӹͼHX3_WXTRevision ͼHX3_LJTRevision װͼHX3_ZPTRevision
//			type = new String[1];
//			type[0] = Ax + "_PRODUCT";
//			break;
//		case "HX3_DJTRevision":// ƷͼЭӹͼHX3_WXTRevision ͼHX3_LJTRevision
//								// װͼHX3_ZPTRevisionͼͼHX3_DJTRevision
//			type = new String[1];
//			type[0] = Ax + "_PRODUCT";
//			break;
//		case "HX3_LJTRevision":// ƷͼЭӹͼHX3_WXTRevision ͼHX3_LJTRevision װͼHX3_ZPTRevision
//			type = new String[1];
//			type[0] = Ax + "_PRODUCT";
//			break;
//		case "HX3_ZPTRevision":// ƷͼЭӹͼHX3_WXTRevision ͼHX3_LJTRevision װͼHX3_ZPTRevision
//			type = new String[1];
//			type[0] = Ax + "_PRODUCT";
//			break;
//		case "HX3_GCGGTZDRevision":// ̸֪ͨ
//			type = new String[1];
//			type[0] = Ax + "_ECN";
//			break;
//		case "HX3_GZTRevision":// װͼ
//			type = new String[2];
//			type[0] = Ax + "_GZT1";
//			type[1] = Ax + "_GZT2";
//			break;
//		default:
//			break;
//		}
//
//		return type;
//	}
	public static String[] selectType(String Ax, String designType) {
	    String[] type = null;

	    if ("HX3_GYTRevision".equals(designType)) { // ͼ
	        if (Ax.equals("A3")) {
	            type = new String[1];
	            type[0] = Ax + "_GY";
	        } else if (Ax.equals("A2")) {
	            type = new String[2];
	            type[0] = Ax + "_GY1";
	            type[1] = Ax + "_GY2";
	        }
	    } else if ("HX3_TYGY1Revision".equals(designType)) { // ͨù
	        if (Ax.equals("A3")) {
	            type = new String[1];
	            type[0] = Ax + "_TYGY";
	        } else if (Ax.equals("A2")) {
	            type = new String[2];
	            type[0] = Ax + "_TYGY1";
	            type[1] = Ax + "_TYGY2";
	        }
	    } else if ("HX3_WXTRevision".equals(designType)) { // ƷͼЭӹͼHX3_WXTRevision ͼHX3_LJTRevision װͼHX3_ZPTRevision
	        type = new String[1];
	        type[0] = Ax + "_PRODUCT";
	    } else if ("HX3_DJTRevision".equals(designType)) { // ƷͼЭӹͼHX3_WXTRevision ͼHX3_LJTRevision
	                                                        // װͼHX3_ZPTRevisionͼͼHX3_DJTRevision
	        type = new String[1];
	        type[0] = Ax + "_PRODUCT";
	    } else if ("HX3_LJTRevision".equals(designType)) { // ƷͼЭӹͼHX3_WXTRevision ͼHX3_LJTRevision װͼHX3_ZPTRevision
	        type = new String[1];
	        type[0] = Ax + "_PRODUCT";
	    } else if ("HX3_ZPTRevision".equals(designType)) { // ƷͼЭӹͼHX3_WXTRevision ͼHX3_LJTRevision װͼHX3_ZPTRevision
	        type = new String[1];
	        type[0] = Ax + "_PRODUCT";
	    } else if ("HX3_GCGGTZDRevision".equals(designType)) { // ̸֪ͨ
	        type = new String[1];
	        type[0] = Ax + "_ECN";
	    } else if ("HX3_GZTRevision".equals(designType)) { // װͼ
	        type = new String[2];
	        type[0] = Ax + "_GZT1";
	        type[1] = Ax + "_GZT2";
	    }

	    return type;
	}

	public static Image[] setPic(Image[] img, String[] sizeType, Properties properties, String markImagePath)
			throws BadElementException, MalformedURLException, IOException {
		// תString·
		img = new Image[sizeType.length];
		for (int k = 0; k < sizeType.length; k++) {

			img[k] = Image.getInstance(markImagePath);// ȡͼƬʵ
			String str = properties.getProperty(sizeType[k]);
			if (str == null) {
				return null;
			}
			String[] values = str.split(",");
			img[k].setAbsolutePosition(Float.valueOf(values[0]), Float.valueOf(values[1]));// ˮӡ½ǵ
		}
		return img;
	}
//
	public static void replaceOrcreate(Dataset arg0, ItemRevision rev) {
		// жϰ汾pdfݼƺcaxaͬо滻ûо½
//		ModelObject[] datasets = null;
//		Dataset dataset = null;
//		try {
//			dmService.getProperties(new ModelObject[] {rev}, new String[] {"IMAN_specification"});
//			datasets =  rev.getPropertyObject("IMAN_specification").getModelObjectArrayValue();;
//			dmService.getProperties(datasets, new String[] {"object_name"});
////			datasets = TcUtils.getWhereReference(new WorkspaceObject[] {arg0});
////			datasets = (TCComponent[]) rev.getTCProperty("IMAN_specification").getReferenceValueArray();
//			String pdfName = "";
//			String caxaName = "";
//			for (int i = 0; i < datasets.length; i++) {
//				if (datasets[i].getTypeObject().getName().equals("PDF")) {
//					pdfName = datasets[i].getPropertyDisplayableValue("object_name");
//					caxaName = arg0.getPropertyDisplayableValue("object_name");
//					if (pdfName.contains(".pdf") && caxaName.contains(".exb")) {
//						pdfName = pdfName.substring(0, pdfName.lastIndexOf(".pdf"));
//						if (debug)
//							System.out.println(pdfName);
//						caxaName = caxaName.substring(0, caxaName.lastIndexOf(".exb"));
//						if (debug)
//							System.out.println(pdfName);
//					}
//				}
//				if (datasets[i].getTypeObject().getName().equals("PDF") && caxaName.equals(pdfName)) {
//					dataset = (Dataset) datasets[i];
//				}
//			}
//			System.out.println();
//		} catch (Exception e1) {
//			e1.printStackTrace();
//		}
//
//		if (dataset == null) {
//			try {
////				if(debug)System.out.println("·0");
//				TcUtils.setByPass(true);
//			} catch (Exception e2) {
//				e2.printStackTrace();
//			}
//			try {
//				dataset = createDataSet(rev,arg0.getPropertyDisplayableValue("object_name").replace(".exb", ".pdf"));//PDF_Reference
//				POM_system_class get_owning_user = rev.get_owning_user();//rev.getPropertyObject("").getModelObjectValue();
//				TcUtils.changeOwnershipModelObject(get_owning_user, "",new ModelObject[] {dataset});
////				TCComponentDatasetType datasetType = (TCComponentDatasetType) session.getTypeComponent("Dataset");
////				dataset = datasetType.create(arg0.getProperty("object_name").replace(".exb", ".pdf"), "", "PDF");
////				rev.add("IMAN_specification", dataset);
//				
//			} catch (Exception e) {
//				e.printStackTrace();
//				try {
////					if(debug)System.out.println("·");
//					TcUtils.setByPass(false);
//				} catch (Exception e2) {
//					e2.printStackTrace();
//				}
//			}
//		}
//		if (dataset == null) {
////			MessageBox.post("ʧ", "", MessageBox.ERROR);
////			return null;
//		}

		try {
			try {
//				if(debug)System.out.println("·1");
				TcUtils.setByPass(true);
			} catch (Exception e2) {
				e2.printStackTrace();
			}

			try {
//				updateDataSet(dataset, addPdfPath, "PDF_Reference");
				//ӷ״̬
				System.out.println("ӷ״̬:"+releaseStatus);
				ReleaseStatus[] get_release_status_list = arg0.get_release_status_list();
				if(get_release_status_list.length == 0) {
					ReleaseStatusInput releaseStatusInput = new ReleaseStatusInput();
					ReleaseStatusOption releaseStatusOption = new ReleaseStatusOption();
					releaseStatusOption.newReleaseStatusTypeName = releaseStatus; 
					 releaseStatusOption.operation = "Append"; 
					 releaseStatusInput.objects = new WorkspaceObject[]{ (WorkspaceObject)arg0 }; 
					 releaseStatusInput.operations = new ReleaseStatusOption[] {releaseStatusOption};
					 WorkflowService workflowService = WorkflowService.getService(AppXSession.getConnection());
					 SetReleaseStatusResponse setReleaseStatus = workflowService.setReleaseStatus(new ReleaseStatusInput[] {releaseStatusInput});
					 System.out.println();
				}
				if(mainArgs.length >=5) {
					//identiyʶ
					System.out.println("identiyʶ"+mainArgs[4]);
					if(mainArgs[4].contains(";")){
						String[] splitIdentity = mainArgs[4].split(";");
						Map<String, DataManagement.VecStruct>  propValueMap = new  HashMap<String, DataManagement.VecStruct>();
						DataManagement.VecStruct vec = new DataManagement.VecStruct();
						vec.stringVec = new String[] { splitIdentity[1]};
						propValueMap.put(splitIdentity[0], vec) ;
						dmService.setProperties(new ModelObject[] {rev}, propValueMap);
					}
					
				}
				
				//ж
				POM_system_class rev_owning = rev.get_owning_user();
				POM_system_class dataset_owning = arg0.get_owning_user();
				if(!rev_owning.getUid().equals(dataset_owning.getUid())) {
					TcUtils.changeOwnershipModelObject(rev_owning, "",new ModelObject[] {arg0});
				}
//				dataset.setFiles(new String[] { addPdfPath }, new String[] { "PDF_Reference" });
			} catch (Exception e) {
				e.printStackTrace();
				try {
					if (debug)
//						System.out.println("滻pdfʧܣ·");
					TcUtils.setByPass(false);
				} catch (Exception e2) {
					e2.printStackTrace();
				}
			}

			try {
//				if(debug)System.out.println("滻pdfɹ·");
				TcUtils.setByPass(false);
			} catch (Exception e2) {
				e2.printStackTrace();
			}
//		if(debug)System.out.println("end");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
//
//	// pdfݼ
//	public void RecreatePdf(TCComponentDataset arg0, TCComponentItemRevision rev) {
//		// жϰ汾pdfݼƺcaxaͬо滻ûо½
//		TCComponent[] datasets = null;
//		TCComponentDataset dataset = null;
//		try {
//			datasets = (TCComponent[]) rev.getTCProperty("IMAN_specification").getReferenceValueArray();
//			String pdfName = "";
//			String caxaName = "";
//			for (int i = 0; i < datasets.length; i++) {
//				if (datasets[i].getProperty("object_type").equals("PDF")) {
//					pdfName = datasets[i].getProperty("object_name");
//					caxaName = arg0.getProperty("object_name");
//					if (pdfName.contains(".pdf") && caxaName.contains(".exb")) {
//						pdfName = pdfName.substring(0, pdfName.lastIndexOf(".pdf"));
//						if (debug)
//							System.out.println(pdfName);
//						caxaName = caxaName.substring(0, caxaName.lastIndexOf(".exb"));
//						if (debug)
//							System.out.println(pdfName);
//					}
//				}
//				if (datasets[i].getProperty("object_type").equals("PDF") && caxaName.equals(pdfName)) {
//					dataset = (TCComponentDataset) datasets[i];
//				}
//			}
//		} catch (TCException e1) {
//			e1.printStackTrace();
//		}
//
//		if (dataset == null) {
//			return;
//		} else {
//
//			try {
//				try {
////				if(debug)System.out.println("·1");
//					ChangeDbomUtil.setByPass(true);
//				} catch (TCException e2) {
//					e2.printStackTrace();
//				}
//
//				try {
//					dataset.removeFiles("PDF_Reference");
//					if (debug)
//						System.out.println("PDFԭɾ");
////					dataset.setFiles(new String[] { addPdfPath}, new String[] { "PDF_Reference" });
//				} catch (Exception e) {
//					e.printStackTrace();
//					try {
//						if (debug)
//							System.out.println("ɾpdfʧܣ·");
//						ChangeDbomUtil.setByPass(false);
//					} catch (TCException e2) {
//						e2.printStackTrace();
//					}
//				}
//
//				try {
////				if(debug)System.out.println("滻pdfɹ·");
//					ChangeDbomUtil.setByPass(false);
//				} catch (TCException e2) {
//					e2.printStackTrace();
//				}
////		if(debug)System.out.println("end");
//			} catch (Exception e) {
//				e.printStackTrace();
//			}
//		}
//
//	}
//
	public static String newString(String oldName) {
//		String newName=oldName;
		if (oldName.contains("/")) {
			if (debug)
				System.out.println("bingo");
			oldName = getNewName("/", oldName);
		}
		if (oldName.contains("*")) {
			oldName = getNewName("*", oldName);
		}
		if (oldName.contains("\\")) {
			oldName = getNewName("\\", oldName);
		}
		if (oldName.contains(":")) {
			oldName = getNewName(":", oldName);
		}
		if (oldName.contains("?")) {
			oldName = getNewName("?", oldName);
		}
		if (oldName.contains("\"")) {
			oldName = getNewName("\"", oldName);
		}
		if (oldName.contains("<")) {
			oldName = getNewName("<", oldName);
		}
		if (oldName.contains(">")) {
			oldName = getNewName(">", oldName);
		}
		if (oldName.contains("|")) {
			oldName = getNewName("|", oldName);
		}
		if (oldName.contains("")) {
			oldName = getNewName("", oldName);
		}
		if (oldName.contains("")) {
			oldName = getNewName("", oldName);
		}
		return oldName;
	}
//
	public static String getNewName(String illegalCharacter, String oldString) {
		if (illegalCharacter.equals("")) {
			oldString = oldString.replace(illegalCharacter, "(");
		} else if (illegalCharacter.equals("")) {
			oldString = oldString.replace(illegalCharacter, ")");

		} else {

			oldString = oldString.replace(illegalCharacter, "--");
		}
		return oldString;
	}
//
//	
//	public void sendMail(String message, String title) throws TCException {
//		TCComponentUserType userType = (TCComponentUserType) session.getTypeComponent("User");
//		TCComponentUser user = userType.find("admin");
//		TCComponent[] targetUser = new TCComponent[] { user };
//		try {
//			TCComponentEnvelopeType type = (TCComponentEnvelopeType) session.getTypeComponent("Envelope");
//			TCComponentEnvelope envelope = type.create(title, message, "");
//			envelope.setProperty("object_name", "caxa" + title);
//			envelope.addReceivers(targetUser);
//			envelope.send();
//		} catch (TCException e) {
//			e.printStackTrace();
//		}
//	}
	public static void main(String[] args) throws Exception {
		mainArgs = args;
		String serverHost = "http://10.10.10.35:8080/tc";
		String host = System.getProperty("host");
		if (host != null && host.length() > 0) {
			serverHost = host;
		}

		session = new AppXSession(serverHost);
		User user = session.login();

		dmService = DataManagementService.getService(AppXSession.getConnection());
		fmu = new FileManagementUtility(AppXSession.getConnection(),
				null,
				new String[] { "http://10.10.10.35:4544" },
				new String[] { "http://10.10.10.35:4544" },
				"D://TEMP//fcc_tmp");
		tcp = PreferenceManagementService.getService(AppXSession.getConnection());
		if(args.length!=5) {
			tryAgain();
		}
		         
		try {
				while(write()) {
					try {
						int sec = new java.util.Random().nextInt(30);
						System.out.println(""+sec+"s");
						Thread.sleep(1000*sec); // 1~10
					} catch (Exception e) {
						
					}
				}
			
			FTPUtils.getConfigureInfomationg(tcp,args[3]);
			
			//ȡݼ
//			DataManagementService dataManagementService = DataManagementService.getService(AppXSession.getConnection());
			
 			
			String revPuids[] = args[0].split(",");
			String puidss[] = args[1].split("\\|");
			for(int i = 0 ; i < revPuids.length ; i++) {
				ItemRevision rev = null;
				try {
					 rev = (ItemRevision) dmService.loadObjects(new String[] {revPuids[i]}).getPlainObject(0);
				}catch(Exception for1) {
					continue;
				}
//				dmService.getProperties(new ModelObject[] {rev}, new String[] {"hx3_identity"});
//				String identity = rev.getPropertyDisplayableValue("hx3_identity");
		//		if(identity != null && "Y".equals(identity)) {
		//			System.out.println("תͼʶ"+identity);
		//			return;
		//		}
				String puids[] = puidss[i].split(",");
				for(String puid : puids) {
					try {
						
						Dataset dataset = (Dataset) dmService.loadObjects(new String[] {puid}).getPlainObject(0);
						releaseStatus = args[2];
						companyName = args[3];
						loadWaitPdf();
						property(dataset,rev);
					}catch(Exception for2) {
						continue;
					}
				}
			}
			
		}catch (Exception e) {
			e.printStackTrace();
		}finally {
			//ɾļ
			String path = caxaPropertyHandler.class.getProtectionDomain().getCodeSource().getLocation().getPath();
			path = path.replace("%20", " ");
			String exePath = new File(path).getParent() + "//";
			if(checkFile("CaxaToPDF.lock",new File(exePath))) {
				String fileName = "CaxaToPDF.lock";
				File lockFile = new File(exePath+ fileName);
				lockFile.delete();
			}
			
		}
		
	}
	public static String consumeInputStream(InputStream is) throws IOException {
		         BufferedReader br = new BufferedReader(new InputStreamReader(is,"GBK"));
		         String s;
		         StringBuilder sb = new StringBuilder();
		         while ((s = br.readLine()) != null) {
		             System.out.println(s);
		             sb.append(s);
		         }
		         return sb.toString();
		     }

	private static void tryAgain() {
		checkDir("D://TEMP//fcc_tmp");
	
	}
	private static void checkDir(String dir) {
		
		File[]files= new File(dir).listFiles();
		List<File> exbFileList = new ArrayList<File>();
		Map<String,String> exbPuidMap = new HashMap<String,String>();
		for(File file:files)
		{
			String fileName = file.getName();
			if(fileName.contains("@")) {
				exbPuidMap.put(fileName.split("@")[0], fileName.split("@")[1]);
			}
			if(fileName.substring(fileName.length()-3, fileName.length()).toLowerCase().equals("exb")) {
				exbFileList.add(file);
			}
			System.out.println(fileName);
		} 
		for(File exbFile : exbFileList) {
			if(exbPuidMap.containsKey(exbFile.getName())) {
			    
				 //ִ
				  String puid = exbPuidMap.get(exbFile.getName());
				  File deleteFile = new File(exbFile.getPath()+"@"+puid);
		          try {
		        	  deleteFile.delete();
		        	  ModelObject plainObject = dmService.loadObjects(new String[] {puid.split("#")[1]}).getPlainObject(0);
		        	  updateDataSet((Dataset) plainObject,exbFile.getPath(),"U2_EXB");
		        	  
//		        	  Runtime runtime = Runtime.getRuntime();  //ȡRuntimeʵ
//		              String[] command = {"cmd", "/c", "start java -jar D:\\Siemens\\Teamcenter11\\portal\\plugins\\CaxaToPDF.jar \""+puid.split("#")[0]+"\" \""+puid.split("#")[1]+"\" \""+puid.split("#")[2]+"\" \""+puid.split("#")[3]+"\" \"Y\""};
//		              Process process = runtime.exec(command);
		        	  String main_args[] = new String[] {puid.split("#")[0],puid.split("#")[1],puid.split("#")[2],puid.split("#")[3],"Y"};
		        	  new caxaPropertyHandler().main(main_args);
		        } catch (Exception e) {
		        	try {
						deleteFile.createNewFile();
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
		             e.printStackTrace();
		         }
				
			}
		}
		System.out.println();
	}
	/**
	 * Ƿȴִ
	 * @return
	 * @throws IOException 
	 */
	private static boolean write() throws IOException {
		String path = caxaPropertyHandler.class.getProtectionDomain().getCodeSource().getLocation().getPath();
		path = path.replace("%20", " ");
		String exePath = new File(path).getParent() + "//";
		if(checkFile("CaxaToPDF.lock",new File(exePath))) {
			return true;
		}
		
		String fileName = "CaxaToPDF.lock";
		File lockFile = new File(exePath+ fileName);
		if (!lockFile.exists()) {
			lockFile.createNewFile();
		}
		System.out.println();
		return false;
	}
	
	private static boolean checkFile(String filename,File dir)
	{
		
		File[]files=dir.listFiles();
		for(File file:files)
		{
			
			if(file.isFile() && filename.equals(file.getName()))  //fileʱļļͬʱ;
			{			
					return true;
			}
		} 
		return false;
	}
	
	private static void writeTime() {
		try {
			int sec = new java.util.Random().nextInt(30);
			System.out.println(""+sec+"s");
			Thread.sleep(1000*sec); // 1~10
		} catch (Exception e) {
			System.out.println("Got an exception!");
		}
		
	
}
	private static void updateDataSet(Dataset dataset, String filePath,String namedRef) throws Exception{
      
//        try {
            
			

            //ȡãļ
            dmService.getProperties(new ModelObject[]{dataset},new String[]{"ref_list"});
            int refListNum = dataset.get_ref_list().length;
            ServiceData removeNamedReferenceFromDatasetServiceDate = null;
            if(refListNum == 0 ){
                System.out.println("ݼã");
            }
            else {
            	//
                com.teamcenter.services.strong.core._2007_09.DataManagement.NamedReferenceInfo[] namedReferenceInfos = new com.teamcenter.services.strong.core._2007_09.DataManagement.NamedReferenceInfo[1];

                for(int i = 0 ; i < refListNum ; i++ ){
                	ImanFile namedRefMobj = (ImanFile) dataset.get_ref_list()[i];
                	
                	dmService.refreshObjects(new ModelObject[] {namedRefMobj});
                	dmService.getProperties(new ModelObject[]{namedRefMobj},new String[]{"file_ext"});
                	String fileExtString  = namedRefMobj.getPropertyObject("file_ext").getStringValue();
                	System.out.println(fileExtString);
                	if(fileExtString.toLowerCase().equals("exb")) {
                		com.teamcenter.services.strong.core._2007_09.DataManagement.NamedReferenceInfo namedReferenceInfo= new com.teamcenter.services.strong.core._2007_09.DataManagement.NamedReferenceInfo();
                        namedReferenceInfo.type = namedRef;
                        namedReferenceInfo.deleteTarget = true;
                        namedReferenceInfo.targetObject = namedRefMobj;
                        namedReferenceInfos[0] = namedReferenceInfo;
                	}
                }

                //ɾ
                com.teamcenter.services.strong.core._2007_09.DataManagement.RemoveNamedReferenceFromDatasetInfo[] removeNamedReferenceFromDatasets = new com.teamcenter.services.strong.core._2007_09.DataManagement.RemoveNamedReferenceFromDatasetInfo[1];
                com.teamcenter.services.strong.core._2007_09.DataManagement.RemoveNamedReferenceFromDatasetInfo removeNamedReferenceFromDataset = new com.teamcenter.services.strong.core._2007_09.DataManagement.RemoveNamedReferenceFromDatasetInfo();
                removeNamedReferenceFromDataset.dataset = dataset;
                removeNamedReferenceFromDataset.nrInfo = namedReferenceInfos;
                removeNamedReferenceFromDatasets[0] = removeNamedReferenceFromDataset;
                removeNamedReferenceFromDatasetServiceDate = dmService.removeNamedReferenceFromDataset(removeNamedReferenceFromDatasets);
            }
            
            if((removeNamedReferenceFromDatasetServiceDate != null 
            		&& removeNamedReferenceFromDatasetServiceDate.sizeOfDeletedObjects() > 0 )
            		|| refListNum == 0){
                System.out.println("ɾɹ");
                //µ
                FileManagement.DatasetFileInfo fileInfo = new FileManagement.DatasetFileInfo();

                fileInfo.allowReplace = false;
//                fileInfo.clientId = fileInfo.toString();
                fileInfo.fileName = filePath;
                fileInfo.isText = false;
                fileInfo.namedReferencedName = namedRef;

                FileManagement.DatasetFileInfo[] fileInfos = { fileInfo };

                FileManagement.GetDatasetWriteTicketsInputData inputData = new FileManagement.GetDatasetWriteTicketsInputData();
                inputData.dataset = dataset;
                inputData.createNewVersion = false;
                inputData.datasetFileInfos = fileInfos;

                FileManagement.GetDatasetWriteTicketsInputData[] inputs = { inputData };
                ServiceData putFilesServiceData = fmu.putFiles(inputs);
//                fileManagementUtility.putFiles(inputs);
                if(putFilesServiceData.sizeOfUpdatedObjects() > 0){
                    System.out.println("");
                }
                fmu.term();


            } else{
                String[] errMsg = removeNamedReferenceFromDatasetServiceDate.getPartialError(0).getMessages();
                System.out.println("ɾʧܣ");
            }
//            throw new Exception("1");
//        } catch (Exception e) {
//            e.printStackTrace();
//        }

    }
	//TCFMSеļת
    public static File TCFileToFile(Dataset dataset) throws Exception{
        if(dataset == null){
            return null;
        }
        //File outFile = null;
        String filename = "";
        
        dmService.getProperties(new ModelObject[] { dataset}, new String[]{"ref_list"});
        ModelObject[] objects = dataset.get_ref_list();
        dmService.getProperties( objects, new String[]{"file_ext"});
        ModelObject tempModelObject =null;
        for(int i =0 ;i< objects.length;i++) {

        	String fileExtString  = objects[i].getPropertyObject("file_ext").getStringValue();
        	if(fileExtString.toLowerCase().equals("exb")) {
        		tempModelObject = objects[i];
        		break;
        	}
        }
        if(tempModelObject == null) {
        	return null;
        }
        objects = new ModelObject[] {tempModelObject};

        GetFileResponse getFileResponse = fmu.getFiles(objects);
        File[] fileinfovec = getFileResponse.getFiles();
        
        

        
        return fileinfovec[0];
    }
	 /***
     * ݼ API
     * @param targetMobj Ŀݼ
     * @param datasetName ݼ
     * @param filePath ļ·
     */
    private static Dataset createDataSet(ModelObject targetMobj,String datasetName) {
       
        //ݼ
        com.teamcenter.services.strong.core._2008_06.DataManagement.DatasetProperties2 datasetProperties2 = new com.teamcenter.services.strong.core._2008_06.DataManagement.DatasetProperties2();
        datasetProperties2.name = datasetName;
        datasetProperties2.type ="PDF";
        datasetProperties2.clientId="PDF_1";
        datasetProperties2.container = targetMobj;
        datasetProperties2.relationType = "IMAN_specification";
        CreateDatasetsResponse ceateDatasetsResponse = dmService.createDatasets2(new com.teamcenter.services.strong.core._2008_06.DataManagement.DatasetProperties2[]{datasetProperties2});
        Dataset dt = ceateDatasetsResponse.output[0].dataset;
        return dt;
//        //
//        FileManagement.DatasetFileInfo fileInfo = new FileManagement.DatasetFileInfo();
//        fileInfo.allowReplace = false;
//        fileInfo.fileName = filePath;
//        fileInfo.isText = false;
//        fileInfo.namedReferencedName = "HG8_dwg";
//        FileManagement.DatasetFileInfo[] fileInfos = { fileInfo };
//
//        //ݼ
//        FileManagement.GetDatasetWriteTicketsInputData inputData = new FileManagement.GetDatasetWriteTicketsInputData();
//        inputData.dataset = dt;
//        inputData.createNewVersion = false;
//        inputData.datasetFileInfos = fileInfos;
//        FileManagement.GetDatasetWriteTicketsInputData[] inputs = { inputData };
//        ServiceData response = fmu.putFiles(inputs);
//        fmu.term();

//       
    }
    // Ӱϻȡ
    public static List<ModelObject> getWhereReference(WorkspaceObject[] obj ,int number){
        List<ModelObject> list = new ArrayList<ModelObject>();
        DataManagement.WhereReferencedResponse response =  dmService.whereReferenced(obj,number);
        DataManagement.WhereReferencedInfo[] info =  response.output[0].info;
        for (int i = 0; i < info.length; i++) {
        	if(info[i].relation.equals("HX3_ggh")) {
        		list.add(info[i].referencer);
        	}
        }
        return list;
    }
    private static Map<String, String> getECNValueMap(ItemRevision rev) throws Exception {
		// 2019.11.254ӳ䣺İΣ汾ţļţ֪ͨıţǩ֣ϹԱڣ֪ͨڣգ
		// ֻһθļ¼
		String dateString = "";
		Map<String, String> valueMap = new HashMap<String,String>();
		List<ModelObject> ecr = getWhereReference(new WorkspaceObject[] {rev}, 1);
//		AIFComponentContext[] ecr = rev.whereReferenced();
		for (int i = 0; i < ecr.size(); i++) {
			if(ecr.get(i) instanceof ItemRevision) {
				ItemRevision ecrRev = (ItemRevision) ecr.get(i);
				dmService.getProperties(new ModelObject[] {ecrRev}, new String[] {"creation_date","item_id"});
				System.out.println("ecrRev.getProperty:" + ecrRev.getTypeObject().getName());
				System.out.println();
				if (ecrRev.getTypeObject().getName().equals("HX3_GCGGTZDRevision")) {
					
						SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
						String dateString2 =  format.format(ecrRev.get_creation_date().getTime()) ;
						String revType = rev.getTypeObject().getName();
						System.out.println("revType:" + revType);
						if (dateString.length() == 0) {
							dateString = dateString2;
							if (revType.equals("HX3_ZPTRevision") || revType.equals("HX3_LJTRevision")
									|| revType.equals("HX3_WXTRevision") || revType.equals("HX3_DJTRevision") || revType.equals("HX3_TYGY1Revision")) {
	
								valueMap.put("İ1", rev.get_item_revision_id());
								valueMap.put("ļ1", ecrRev.get_item_id());
								valueMap.put("ǩ1", "ϹԱ");
								valueMap.put("1", format.format(ecrRev.get_creation_date().getTime()));
							} else if (revType.equals("HX3_GYTRevision")) {
								valueMap.put("İ", rev.get_item_revision_id());
								valueMap.put("ļ", ecrRev.get_item_id());
								valueMap.put("ǩ", "ϹԱ");
								valueMap.put("", format.format(ecrRev.get_creation_date().getTime()));
	
							}
						} else {
							if (dateString.compareTo(dateString2) < 0) {
								dateString = dateString2;
								if (revType.equals("HX3_ZPTRevision") || revType.equals("HX3_LJTRevision")
										|| revType.equals("HX3_WXTRevision")|| revType.equals("HX3_DJTRevision")|| revType.equals("HX3_TYGY1Revision")) {
	
									valueMap.put("İ1", rev.get_item_revision_id());
									valueMap.put("ļ1", ecrRev.get_item_id());
									valueMap.put("ǩ1", "ϹԱ");
									valueMap.put("1", format.format(ecrRev.get_creation_date().getTime()));
								} else if (revType.equals("HX3_GYTRevision")) {
									valueMap.put("İ", rev.get_item_revision_id());
									valueMap.put("ļ", ecrRev.get_item_id());
									valueMap.put("ǩ", "ϹԱ");
									valueMap.put("", format.format(ecrRev.get_creation_date().getTime()));
	
								}
							}
						}
					}

				
			}
			
		}
		return valueMap;
		
	}
}
